      subroutine ExportM91
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      include 'editm9.cmn'
      include 'datred.cmn'
      dimension h(3),fp(mxref),sp(mxref),hp(6),ntwq(-18:18),difi(3),
     1          ihi(6)
      character*128 Ven(4)
      character*80 t80,p80,ta80(2)
      character*2 nty
      logical FeYesNo,VicSkal,RedukceDolu,m89opened,ExistFile,
     1        FeYesNoHeader,Nulova
      equivalence (fia,fp),(sigfia,sp),(t80,ta80(1)),(p80,ta80(2))
      data difi/3*.01/
      if(.not.ExistFile(fln(:ifln)//'.m95')) then
        call FeChybne(-1.,-1.,'M91 file cannot be created as file',
     1                fln(:ifln)//'.m95 doesn''t exist',0,SeriousError)
        go to 9900
      endif
      call NewPg(1)
      Name=' '
      Title=' '
      uloha='Creating of the JANA reflection file'
      call OpenFile(lst,fln(:ifln)//'.rre','formatted','unknown')
      if(ErrJana.ne.0) go to 9900
      LstOpened=.true.
      call iom94(0)
      if(ErrJana.ne.0) go to 9900
      call iom50(0,1)
      if(ErrJana.ne.0) go to 9900
      if(StatusM50.gt.100) then
        call FeChybne(-1.,-1.,'M50 doesn''t contain either parameters '
     1              //'or symmetry information',' ',0,SeriousError)
        go to 9900
      endif
      call OpenFile(90,fln(:ifln)//'.l90','formatted','unknown')
      if(ErrJana.ne.0) go to 9900
      if(CorrLp.le.0) then
        call FeChybne(-1.,-1.,'LP correction has not been applied',' ',
     1                0,SeriousError)
        go to 9999
      endif
      scf=1.
      call OpenFile(95,fln(:ifln)//'.m95','formatted','old')
      if(ErrJana.ne.0) go to 9900
      t80=fln(:ifln)//'.m97'
      Profil=ExistFile(t80)
      if(Profil) open(97,file=t80,form='unformatted',status='unknown',
     1                access='direct',recl=120*4,err=1000)
      go to 1100
1000  Profil=.false.
1100  call FeGetILevel('Observability level used by the export routine',
     1                 'Reflections I<',
     2                 '*sig(I) will be sorted as unobserved',
     3                 'Note: this number is not interpreted by REFINE',
     4                 EM9ObsLim,ich)
      if(ich.ne.0) go to 9900
      call OpenFile(89,fln(:ifln)//'_makem91.tmp','formatted','unknown')
      m89opened=ErrJana.eq.0
      if(m89opened) then
        write(89,'(''makem91'')')
        write(Cislo,'(f8.3)') EM9ObsLim
        call ZdrcniCisla(Cislo,1)
        write(89,'(''siglevp: '',15a1)')(Cislo(i:i),i=1,idel(Cislo))
      endif
      call OpenFile(61,fln(:ifln)//'.l61','formatted','unknown')
      if(ErrJana.ne.0) go to 9200
      RedukceDolu=.false.
      if(nref95.le.0) nref95=10000
      call FeFlowChartOpen(-1.,-1.,max(nint(float(nref95)*.005),10),
     1                     nref95,'Creating refinement reflection file',
     2                     ' ',' ')
2005  if(Profil) then
        nrecc=1
        read(97,rec=nrecc)
      endif
      fomax=0.
      iz=0
      call SetIntArrayTo(ihmin,ndim, 9999)
      call SetIntArrayTo(ihmax,ndim,-9999)
      thmin= 9999.
      thmax=-9999.
      NExt=0
      NExtObs=0
      NExt15=0
      avis=0.
      rcc=0.
      rjc=0.
      rcn=0.
      rjn=0.
      NRef90=0
      NRef90Obs=0
      NRead=0
      NReadObs=0
      rimax=0.
      do 2040i=-18,18
        ntwq(i)=0
2040  continue
      nq=0
      itwmax=0
      itwmin=1
      if(ndim.eq.4.and.kcommen.eq.1) call comsym(0,1)
      call PrvniM95(ich)
      if(ich.ne.0) go to 9200
2100  read(95,format95,end=5000,err=9000) no,(ihi(i),i=1,ndim),
     1                     (ri,i=1,5),rs,tbar,iq,itw,corrf,tbar,DirCos
      if(itw.eq.0) itw=1
      iatw=iabs(itw)
      call RestorePhase(KPhaseTwin(iatw))
      if(Profil) then
        nrecc=nrecc+1
        read(97,rec=nrecc)(ihi(i),i=1,ndim),(ri,i=1,5),i,(ri,i=1,6),rs,
     1                     rs
      endif
      if(iatw.gt.itwin) then
        write(t80,format91)(ihi(i),i=1,ndim),ri,rs,iq,0,itw
        call FeChybne(-1.,-1.,'disagreement between twin flag and '//
     1                'number of twin domains','for reflection : '//
     2                t80(:idel(t80)),0,SeriousError)
        go to 9100
      endif
      call FeFlowChartEvent(iz,ie)
      if(ie.ne.0) then
        call FeBudeBreak
        if(ErrJana.ne.0) go to 9100
      endif
      if(no.gt.0) then
        pom1=corrf(1)*corrf(2)*scf
        ri=ri*pom1
        rs=rs*pom1
        if(rs.le.0.05) then
          if(.not.RedukceDolu.and.rs.gt.0.) then
2200        if(rs.le..05) then
              scf=scf*10.
              rs=rs*10.
              go to 2200
            endif
            rewind 95
            rewind 90
            rewind 61
            call FeFlowChartRefresh
            go to 2005
          endif
          rs=0.1
        endif
      else
        go to 2100
      endif
      NRead=NRead+1
      Nulova=.true.
      if(anint(ri*10.).gt.EM9ObsLim*anint(rs*10.)) then
        Nulova=.false.
        NReadObs=NReadObs+1
      endif
      call indtr(ihi,trmp,ih,ndim)
      if(ih(1).gt.900) then
        call CopyVekI(ih,ihp,ndim)
        go to 3000
      endif
      mmax=0
      do 2215isw=1,ncomp
        call IndTr(ih,zvi(1,isw,KPhase),ihp,ndim)
        do 2210i=4,ndim
          mmax=max(iabs(ihp(i)),mmax)
          if(isw.eq.1) hp(i)=0.
2210    continue
2215  continue
      do 2230i=1,3
        h(i)=ih(i)
        do 2220j=1,ndimi
          h(i)=h(i)+qu(i,j,1,KPhase)*float(ih(j+3))
2220    continue
2230  continue
      call multm(h,rtwi(1,iatw),hp,1,3,3)
      call IndFromIndReal(hp,mmax,difi,ihp,itwp,iswp,-1.)
      if(iswp.le.0) go to 3000
      call RestorePhase(KPhaseTwin(iatw))
      call FromIndSinthl(ih,h,sinthl,sinthlq,1,0)
      pom1=sinthl*LamAve(1)
      if(abs(pom1).gt..999999) then
        NInfo=2
        write(t80,'(''('',6(i5,'',''))')(ihi(i),i=1,ndim)
        call zhusti(t80)
        i=idel(t80)
        if(t80(i:i).eq.',') i=i-1
        TextInfo(1)='The reflection '//t80(:i)//
     1              ') has unrealistic indices'
        TextInfo(2)='It gives sin(theta)>1 and it will be skipped'
        call FeMouseShape(0)
        if(FeYesNoHeader(-1.,30.,'Do you want to stop?',1)) then
          go to 9100
        else
          call FeMouseShape(3)
          go to 2100
        endif
      endif
      pom1=asin(sinthl*LamAve(1))/torad
      thmin=min(thmin,pom1)
      thmax=max(thmax,pom1)
      fomax=max(fomax,ri)
      if(fomax.gt.999999.9) then
        RedukceDolu=.true.
2300    if(fomax.gt.999999.9) then
          scf=scf*.1
          fomax=fomax*.1
          go to 2300
        endif
        rewind 95
        rewind 90
        rewind 61
        call FeFlowChartRefresh
        go to 2005
      endif
      do 2920i=1,6
        ihmax(i)=max(ihmax(i),ih(i))
        ihmin(i)=min(ihmin(i),ih(i))
2920  continue
      rcc=rcc+rs
      rjc=rjc+ri
      NRef90=NRef90+1
      if(.not.Nulova) then
        rcn=rcn+rs
        rjn=rjn+ri
        NRef90Obs=NRef90Obs+1
        sp(NRef90Obs)=sinthl
        fp(NRef90Obs)=ri
      endif
      if(iq.eq.0) iq=1
      ntwq(itw)=max(ntwq(itw),iq)
      itwmin=min(itwmin,itw)
      itwmax=max(itwmax,itw)
      nq=max(nq,iq)
      nxx=0
      write(90,format91)(ih(i),i=1,ndim),ri,rs,iq,nxx,itw,tbar,DirCos
      go to 2100
3000  if(NExt.le.0) rewind 61
      write(t80,'(6i4)')(ihi(i),i=1,ndim)
      write(t80(ndim*4+1:),'(1x,3f9.1)') ri,rs,ri/rs
      write(61,FormA1)(t80(i:i),i=1,idel(t80))
      call EM9NejdouPotvory(ihi,hp,ri,rs,ndim,avis,NExt,NExtObs,NExt15,
     1  iha,hfa,ipor,ria,rsa,rimax,EM9ObsLim,.false.)
      go to 2100
5000  write(90,'('' 999'')')
      call FeFlowChartRemove
      call NewPg(0)
      NInfo=3
      write(t80,100) NReadObs,NRead
      call Zhusti(t80)
      i=idel(t80)
      j=index(t80,'/')
      TextInfo(1)=t80(:i)//' reflections read from input file'
      write(t80,100) NRef90Obs,NRef90
      call Zhusti(t80)
      k=j-index(t80,'/')+1
      l=i-k+1
      TextInfo(2)=' '
      TextInfo(2)(k:)=t80(:l)//' reflections written to output file'
      if(NExt.gt.0) then
        write(t80,100) NExtObs,NExt
        call Zhusti(t80)
        k=j-index(t80,'/')+1
        l=i-k+1
        TextInfo(3)=' '
        TextInfo(3)(k:)=t80(:l)//
     1    ' reflections rejected as systematically extint'
        if(NExtObs.gt.0) then
          NInfo=NInfo+1
          TextInfo(4)='List of the strongest rejected reflections '//
     1                'follows'
        endif
      else
        TextInfo(3)='There were no rejections due to systematic '//
     1              'extintions'
      endif
      call FeInfoOut(-1.,-1.,'Import statistics - obs/all')
      call TitulekVRamecku('Summary of reflections before averaging')
      call Newln(2)
      write(lst,'(''Reflections with I<'',f5.2,''*sig(I) will be '',
     1            ''classified as unobserved''/)') EM9ObsLim
      if(abs(scf-1.).gt..5) then
        call newln(1)
        if(scf.gt.1.) then
          write(Cislo,'(f15.0)') scf
        else
          write(Cislo,'(f15.5)') scf
        endif
        call ZdrcniCisla(Cislo,1)
        write(lst,'(''Intesities from M95 were rescaled by the factor ''
     1              ,a)') Cislo(:idel(Cislo))
        call newln(1)
        write(lst,FormA1)
      endif
      do 5100i=1,3
        call newln(1)
        write(lst,FormA1)(TextInfo(i)(j:j),j=1,idel(TextInfo(i)))
5100  continue
      call Newln(ndim+1)
      write(lst,FormA1)
      Ninfo=ndim+3
      do 5110i=1,ndim
        write(lst,'(17x,a1,''(min) = '',i4,'','',a1,''(max) = '',i4)')
     1    indices(i),ihmin(i),indices(i),ihmax(i)
5110  continue
      rn=rcn/rjn*100.
      rc=rcc/rjc*100.
      call Newln(2)
      write(lst,FormA1)
      write(lst,104) rn,rc
      if(m89opened) then
        write(89,'(''limits90:'',12i4)')(ihmin(i),ihmax(i),i=1,ndim)
        write(89,'(''number90:'',i6)') NRef90
        write(89,'(''thmin/max:'',2f8.2)') thmin,thmax
      endif
      if(NExtObs.gt.0) then
        call Newln(4)
        write(lst,FormA1)
        write(lst,'(''List of reflections absent due to systematic '',
     1              ''extinctions'')')
        write(lst,FormA1)
        write(t80,'(6(3x,a1))')(indices(i),i=1,ndim)
        idl=idel(t80)+1
        t80(idl:)='       I      sig(I)  I/sig(I)'
        idl=idel(t80)
        write(lst,FormA1)(t80(i:i),i=1,idl),(' ',i=1,10),
     1                   (t80(i:i),i=1,idl)
        rewind 61
        j=0
5120    j=j+1
        read(61,FormA80,end=5130) Ta80(j)
        if(j.eq.2) then
          call Newln(1)
          write(lst,FormA1)(t80(i:i),i=1,idl),(' ',i=1,10),
     1                     (p80(i:i),i=1,idl)
          j=0
        endif
        go to 5120
5130    if(j.ne.0) then
          call Newln(1)
          write(lst,FormA1)(t80(i:i),i=1,idl)
        endif
      endif
      close(61,status='delete')
      if(NExtObs.gt.0) then
        call TitulekVRamecku('Summary of extinctions')
        if(NExt.ne.0) then
          avis=avis/float(NExt)
        else
          avis=0.
        endif
        write(TextInfo(1),'(''Overall           n(all) :'',i5,
     1                      '' n(obs) :'',i5)') NExt,NExtObs
        write(TextInfo(2),'(18x,''Average(I/Sig(I)) : '',f5.2)')
     1        avis
        if(NExt15.ne.15) call Indexx(NExt15,ria,ipor)
        TextInfo(3)='            List of the strongest ones'
        write(t80,EM9Form1)(indices(i),i=1,ndim)
        idl=idel(t80)+1
        t80(idl:)='       I      sig(I)  I/sig(I)'
        call newln(1)
        write(lst,FormA1)(t80(j:j),j=1,idel(t80))
        TextInfo(4)=t80
        do 5250i=5,NExt15+4
          k=ipor(i-4)
          write(t80,EM9Form2)(iha(j,k),j=1,ndim)
          pom1=-float(ria(k))*.01
          pom2= float(rsa(k))*.01
          write(t80(idl:),'(1x,2f9.1,f9.1)') pom1*pom2,pom2,pom1
          TextInfo(i)=t80
          call newln(1)
          write(lst,FormA1)(t80(j:j),j=1,idel(t80))
5250    continue
        Ninfo=NExt15+4
        call FeInfoOut(-1.,-1.,'Summary of extinctions')
      endif
      call heap(NRef90Obs,sp)
      call heap(NRef90Obs,fp)
      sinmez(8)=sp(NRef90Obs)+.000001
      fmez(8)=fp(NRef90Obs)+.1
      d=0.
      dd=float(NRef90Obs)*.125
      do 5500i=1,7
        d=d+dd
        j=d
        sinmez(i)=(sp(j)+sp(j+1))*.5
        fmez(i)=(fp(j)+fp(j+1))*.5
5500  continue
      call CloseIfOpened(95)
      call CloseIfOpened(90)
      VicSkal=nq.gt.1
      nrefav=0
      nrefsc=NRef90*(nq+2)
      do 5505i=itwmin,itwmax
        nrefav=nrefav+2*ntwq(i)*NRef90
5505  continue
      do 5510i=1,ns
        call MatBlock3(rm6(1,i,1,KPhase),rm(1,i,1,KPhase),ndim)
5510  continue
      if(.not.VicSkal) go to 5550
      if(FeYesNo(-1.,-1.,'Do you want transform data to common scale?',
     1           1)) then
        callOpenFile(90,fln(:ifln)//'.l90','formatted','unknown')
        if(ErrJana.ne.0) go to 9200
        call OpenFile(91,fln(:ifln)//'.l91','formatted','unknown')
        if(ErrJana.ne.0) go to 9200
        call EM9MakeScales(0,0,ich)
        if(ich.ne.0) go to 5520
        call FeFlowChartOpen(-1.,-1.,max(nint(float(nrefsc)*.005),10),
     1                       nrefsc,
     2                       'Transformation to common scale',' ',
     3                       ' ')
        call EM9MakeScales(1,1,ich)
        if(ich.ne.0) go to 5520
        do 5516j=2,nq
          call EM9MakeScales(j,2,ich)
          if(ich.ne.0) go to 5520
5516    continue
        call EM9MakeScales(j,3,ich)
5520    call FeFlowChartRemove
        call CloseIfOpened(90)
        call CloseIfOpened(91)
        if(ich.eq.1) then
          go to 5550
        else if(ich.eq.2) then
          go to 8000
        endif
        Ninfo=nq+1
        TextInfo(1)='Set     No of all  No of common  Scale'
        sckor(1)=1.
        sccom(1)=0
        do 5525j=1,nq
          write(TextInfo(j+1),'(i2,3x,i10,2x,i10,4x,f8.4)') j,
     1      scref(j),sccom(j),sckor(j)
          if(j.gt.1) then
            write(t80,'(''('',i15,'')'')') nint(sckors(j)*10000.)
            call zhusti(t80)
            TextInfo(j+1)=TextInfo(j+1)(:39)//t80(:idel(t80))
          else
            TextInfo(j+1)(25:27)='---'
          endif
5525    continue
        t80='Summary from transformation to the common scale'
        call FeInfoOut(-1.,-1.,t80)
        call TitulekVRamecku(t80)
        call NewLn(Ninfo)
        do 5526i=1,NInfo
          write(lst,FormA1)(TextInfo(i)(j:j),j=1,idel(TextInfo(i)))
5526    continue
        do 5527i=itwmin,itwmax
          ntwq(i)=1
5527    continue
        nrefav=2*(itwmax-itwmin+1)*NRef90
        call move(fln(:ifln)//'.l91',fln(:ifln)//'.l90',.false.)
      endif
5550  if(FEYesNo(-1.,-1.,'Do you want to average reflections?',1)) then
        call OpenFile(90,fln(:ifln)//'.l90','formatted','unknown')
        if(ErrJana.ne.0) go to 9200
        call OpenFile(91,fln(:ifln)//'.l91','formatted','unknown')
        if(ErrJana.ne.0) go to 9200
        NRef91=0
        Prumer=.false.
        call SetRealArrayTo(rnum ,11,0.)
        call SetRealArrayTo(rden ,11,0.)
        call SetRealArrayTo(ronum,11,0.)
        call SetRealArrayTo(roden,11,0.)
        call SetRealArrayTo(resdnum ,11,0.)
        call SetRealArrayTo(resdden ,11,0.)
        call SetRealArrayTo(roesdnum,11,0.)
        call SetRealArrayTo(roesdden,11,0.)
        call SetIntArrayTo(nrefi ,11,0)
        call SetIntArrayTo(norefi,11,0)
        call SetIntArrayTo(nrefa ,11,0)
        call SetIntArrayTo(norefa,11,0)
        mmMax=0
        call NewPg(0)
        call TitulekVRamecku('Report from averaging reflections')
        call EM9Average(0,0,0,ich)
        if(ich.ne.0) then
          call CloseIfOpened(90)
          call CloseIfOpened(91)
          call move(fln(:ifln)//'.l90 ',fln(:ifln)//'.l91',.false.)
          go to 9200
        endif
        call FeFlowChartOpen(-1.,-1.,max(nint(float(nrefav)*.005),10),
     1                       nrefav,'Averaging reflections from M95',
     2                       ' ',' ')
        do 5620i=itwmin,itwmax
          if(i.eq.0) go to 5620
          do 5610j=1,ntwq(i)
            if(line.gt.40) then
              call NewPg(0)
            endif
            if(itwmax.gt.itwmin.or.ntwq(i).gt.1) then
              call newln(3)
              if(itwmax.gt.itwmin) then
                if(ntwq(i).le.1) then
                  write(lst,'(/''Averaging from '',i2,a2,
     1                         '' domain fraction''/)') i,nty(i)
                else
                  write(lst,'(/''Averaging of '',i2,a2,
     1                         '' domain fraction, scale #'',i2/)')
     2              i,nty(i),j
                endif
              else
                write(lst,'(/''Averaging date with scale #'',i2/)') j
              endif
            endif
            call EM9Average(i,j,1,ich)
            if(ich.ne.0) go to 9100
5610      continue
5620    continue
        call FeFlowChartRemove
        write(91,'('' 999'')')
        close(90,status='delete')
        call NewPg(0)
        call TitulekVRamecku('Summary of reflections after averaging')
        i=ndim+5
        if(ncull.gt.0) i=i+1
        call Newln(i)
        do 5630i=1,ndim
          ihmin(i)= 9999
          ihmax(i)=-9999
5630    continue
        rcc=0.
        rjc=0.
        rcn=0.
        rjn=0.
        NRef91Obs=0
        rewind 91
5700    read(91,format91)(ih(k),k=1,ndim),ri,rs,iq,nxx,itw,tbar
        if(ih(1).gt.900) go to 5800
c        iatw=iabs(itw)
        do 5710i=1,6
          ihmax(i)=max(ihmax(i),ih(i))
          ihmin(i)=min(ihmin(i),ih(i))
5710    continue
        call FromIndSinthl(ih,h,sinthl,sinthlq,1,0)
        rcc=rcc+rs
        rjc=rjc+ri
        NRef91=NRef91+1
        if(anint(ri*10.).gt.EM9ObsLim*anint(rs*10.)) then
          rcn=rcn+rs
          rjn=rjn+ri
          NRef91Obs=NRef91Obs+1
          sp(NRef91Obs)=sinthl
          fp(NRef91Obs)=ri
        endif
        go to 5700
5800    Ninfo=ndim+4
        if(ncull.ge.0) Ninfo=Ninfo+1
        if(prumer) then
          rave=rnum(1)/rden(1)
          if(roden(1).gt.0.) then
            write(t80,'(f6.2,''/'',f6.2)') ronum(1)/roden(1)*100.,
     1                                     rave*100.
          else
            if(rden(1).gt.0.) then
              write(t80,'(''-----/'',f6.2)') rnum(1)/rden(1)*100.
            else
              write(t80,'(''-----/-----'')')
            endif
          endif
        else
          write(t80,'(''-----/-----'')')
        endif
        call Zhusti(t80)
        TextInfo(1)='Rint(obs/all) = '//t80(:idel(t80))
        write(t80,100) NRef91Obs,NRef91
        call Zhusti(t80)
        j=idel(TextInfo(1))
        TextInfo(1)=TextInfo(1)(:j)//' for '//t80(:idel(t80))//
     1              ' reflections'
        write(t80,100) NRef90Obs,NRef90
        call Zhusti(t80)
        TextInfo(2)=' '
        TextInfo(2)=TextInfo(2)(:j-9)//'averaged from '//t80(:idel(t80))
     1            //' reflections'
        write(t80,'(f10.3)') float(NRef90)/float(NRef91)
        call ZdrcniCisla(t80,1)
        TextInfo(3)='Redundancy = '//t80(:idel(t80))
        do 5815k=1,3
          write(lst,FormA1)(TextInfo(k)(j:j),j=1,idel(TextInfo(k)))
5815    continue
        write(lst,FormA1)
        do 5820i=1,ndim
          write(TextInfo(i+3),'(17x,a1,''(min) = '',i4,'','',a1,
     1          ''(max) = '',i4)') indices(i),ihmin(i),indices(i),
     2                             ihmax(i)
          write(lst,FormA1)(TextInfo(i+3)(j:j),j=1,idel(TextInfo(i+3)))
5820    continue
        rn=rcn/rjn*100.
        rc=rcc/rjc*100.
        write(lst,FormA1)
        i=ndim+4
        write(TextInfo(i),104) rn,rc
        write(lst,FormA1)(TextInfo(i)(j:j),j=1,idel(TextInfo(i)))
        if(ncull.ge.0) then
          if(ncull.gt.0) then
            write(t80,FormI15) ncull
            call zhusti(t80)
            t80=t80(:idel(t80))//' reflections were culled'
          else
            t80='no reflection was culled'
          endif
          i=i+1
          TextInfo(i)='Information from culling : '//t80(:idel(t80))
          write(lst,FormA1)(TextInfo(i)(j:j),j=1,idel(TextInfo(i)))
        endif
        call FeInfoOut(-1.,-1.,'Summary of reflections after averaging')
        if(ndimi.gt.0) then
          call Newln(14)
          write(lst,'(/''Rint and other characteritics as a function '',
     1                ''of satellite index''/)')
          ven(1)='Satelite index'
          l=20
          do 5900i=2,mmMax
            write(Cislo,'(6x,''+-('',i1,'')'')') i-2
            if(i.eq.2) Cislo(7:8)='  '
            ven(1)(l:)=Cislo(:11)
            l=l+11
5900      continue
          write(lst,FormA1)(ven(1)(l:l),l=1,idel(Ven(1)))
          write(lst,FormA80)
          ven(1)='Obs  Resd'
          ven(2)='     Rint'
          ven(3)='     Number'
          ven(4)='     Averaged from'
          l=20
          do 5905i=2,mmMax
            if(roesdden(i).gt.0.) then
              write(ven(1)(l:),'(f11.2)') roesdnum(i)/roesdden(i)*100.
            else
              ven(1)(l:)='     ------'
            endif
            if(roden(i).gt.0.) then
              write(ven(2)(l:),'(f11.2)') ronum(i)/roden(i)*100.
            else
              ven(2)(l:)='     ------'
            endif
            write(ven(3)(l:),'(i11)') norefa(i)
            write(ven(4)(l:),'(i11)') norefi(i)
            l=l+11
5905      continue
          do 5906i=1,4
            write(lst,FormA1)(ven(i)(l:l),l=1,idel(Ven(i)))
5906      continue
          write(lst,FormA80)
          ven(1)='All  Resd'
          l=20
          do 5910i=2,mmMax
            if(resdden(i).gt.0.) then
              write(ven(1)(l:),'(f11.2)') resdnum(i)/resdden(i)*100.
            else
              ven(1)(l:)='     ------'
            endif
            if(rden(i).gt.0.) then
              write(ven(2)(l:),'(f11.2)') rnum(i)/rden(i)*100.
            else
              ven(2)(l:)='     ------'
            endif
            write(ven(3)(l:),'(i11)') nrefa(i)
            write(ven(4)(l:),'(i11)') nrefi(i)
            l=l+11
5910      continue
          do 5911i=1,4
            write(lst,FormA1)(ven(i)(l:l),l=1,idel(Ven(i)))
5911      continue
        endif
        if(ndim.eq.4.and.kcommen.eq.1) then
          k=NRef91
          call iom50(0,0)
          do 6050i=1,ns
            do 6045j=1,ndimq
              mr6(j,i,1,KPhase)=nint(rm6(j,i,1,KPhase))
6045        continue
6050      continue
          NRef91=k
        endif
        if(NRef91Obs.gt.7) then
          call heap(NRef91Obs,sp)
          call heap(NRef91Obs,fp)
          sinmez(8)=sp(NRef91Obs)+.000001
          fmez(8)=fp(NRef91Obs)+.1
          d=0.
          dd=float(NRef91Obs)*.125
          do 7000i=1,7
            d=d+dd
            j=d
            sinmez(i)=(sp(j)+sp(j+1))*.5
            fmez(i)=(fp(j)+fp(j+1))*.5
7000      continue
        endif
        if(m89opened) then
          if(Prumer) then
            write(89,108) rave,rc*.01
          else
            write(89,108) 0.,rc*.01
          endif
        endif
      else
        call move(fln(:ifln)//'.l90 ',fln(:ifln)//'.l91',.false.)
        NRef91=NRef90
        if(m89opened) write(89,108) 0.,rc*.01
      endif
      call CloseIfOpened(91)
      if(m89opened) write(89,'(''end'')')
8000  if(FeYesNo(-1.,-1.,'Do you want to accept the new M91?',1)) then
        call move(fln(:ifln)//'.l91',fln(:ifln)//'.m91',.false.)
        call iom50(1,0)
        M91Changed=.true.
        call CloseIfOpened(89)
      else
        call DeleteFile(PreviousM50)
        call DeleteFile(fln(:ifln)//'.l91')
        close(89,status='delete')
      endif
      go to 9900
9000  call FeReadError(95)
9100  call FeFlowChartRemove
9200  close(89,status='delete')
9900  call CloseIfOpened(lst)
      call CloseIfOpened(61)
      do 9910i=89,91
        call CloseIfOpened(i)
9910  continue
      call CloseIfOpened(95)
      call CloseIfOpened(97)
      LinuxString=fln(:ifln)//'_makem91.tmp'
      if(ExistFile(LinuxString).and.ErrJana.eq.0)
     1   call UpdateSummary('makem91')
9999  return
100   format(i15,'/'i15)
103   format('Exported ',i6,' reflections, ',i6,' observed ones')
104   format('R(obs/all) from e.s.d. of I : ',f5.2,'/',f5.2)
108   format('Rave:',2f8.4)
      end
      subroutine EM9Average(kitw,kiq,klic,ich)
      parameter (mxgrav=500)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      include 'editm9.cmn'
      include 'datred.cmn'
      dimension ihmaxp(6),maxi(6),maxip(6),tp(mxref),icull(mxgrav),
     1          mp(36)
      character*80 t80
      character*20 FormRefAve
      character*42 iven(mxl4)
      character*4  iven1
      integer EM9SortIndex
      logical tisk,lcull,Psal,CrwLogicQuest
      equivalence (tp,riar)
      save mxl34,ncsp,flimp,fcullp,izp,Psal,FormRefAve
      data flim,fcull/5.,-1./,iven,isigm/mxl4*' ',1/,ix,iz/1,3/
      rewind 90
      if(klic.eq.0) then
        if(ndim.gt.3) then
          mxl34=3*(mxline-5)
        else
          mxl34=4*(mxline-5)
        endif
        FormRefAve='(3i4,f 9.1,f 6.1,a4)'
        if(ndim.gt.3) then
          n=20-2*ndim
          write(FormRefAve(2:2),102) ndim
          write(FormRefAve(7:8),106) n
          write(FormRefAve(13:14),106) n-2
          FormLabAve='(3(''   h   k   l'
          if(ndim.gt.3) FormLabAve=FormLabAve(:idel(FormLabAve))//'   m'
          if(ndim.gt.4) FormLabAve=FormLabAve(:idel(FormLabAve))//'   n'
          if(ndim.gt.5) FormLabAve=FormLabAve(:idel(FormLabAve))//'   p'
          t80=''',  x,''I '',  x,''sig(I)'',3x)/)'
          write(t80(3:4),106) n-2
          write(t80(12:13),106) n-7
          FormLabAve=FormLabAve(:idel(FormLabAve))//t80(:idel(t80))
        else
          FormLabAve='(4(''   h   k   l      I    sig(I)   '')/)'
        endif
        flimo=flim
        fcullo=fcull
        id=NextQuestId()
        call FeQuestCreate(id,-1.,-1.,215.,0,12,'Averaging parameters',
     1                     0,LightGray,0,0)
        xpom=124.
        do 1000i=1,3
          call FeQuestCrwMake(id,xpom,1,xpom-4.,2,indices(i),'C',CrwgXd,
     1                        CrwgYd,1,1)
          call FeQuestCrwOpen(i,i.eq.iz)
          xpom=xpom+14.
1000    continue
        xpom=124.
        do 1050i=1,3
          call FeQuestCrwMake(id,xpom,1,xpom-4.,3,' ','C',CrwgXd,CrwgYd,
     1                        1,2)
          call FeQuestCrwOpen(i+3,i.eq.ix)
          if(i.eq.iz) call FeQuestCrwClose(i+3)
          xpom=xpom+14.
1050    continue
        call FeQuestLabelMake(id,5.,2,'The slowest varying index','L')
        call FeQuestLabelMake(id,5.,3,'The fastest varying index','L')
        call FeQuestLineMake(id,4)
        call FeQuestCrwMake(id,5.,5,43.,5,'%Full print','L',CrwXd,CrwYd,
     1                      1,0)
        call FeQuestCrwOpen(7,flim.lt.0.)
        t80='Reflections |I-I(ave)|>'
        call FeQuestLabelMake(id,5.,6,t80,'L')
        xpom=FeTxLength(t80)+7.
        call FeQuestEdwMake(id,xpom+22.,6,xpom,6,
     1                      '*sig(I(ave)) will be %printed','L',20.,
     2                      EdwYd,0)
        if(flim.ge.0.) then
          call FeQuestRealEdwOpen(1,flim,.false.,.false.)
        else
          call FeQuestCrwOn(7)
          flimp=5.
        endif
        call FeQuestCrwMake(id,59.,5,108.,5,'%Apply culling','L',CrwXd,
     1                      CrwYd,1,0)
        call FeQuestCrwOpen(8,fcull.gt.0.)
        t80='Reflections |I-I(ave)|>'
        call FeQuestLabelMake(id,5.,7,t80,'L')
        xpom=FeTxLength(t80)+7.
        call FeQuestEdwMake(id,xpom+22.,7,xpom,7,
     1                      '*sig(I(ave)) will be %culled','L',20.,
     2                      EdwYd,0)
        if(fcull.ge.0.) then
          call FeQuestRealEdwOpen(2,fcull,.false.,.false.)
        else
          fcullp=20.
        endif
        call FeQuestLineMake(id,8)
        call FeQuestLabelMake(id,107.5,9,'Sigma(I(ave)) take from :',
     1                        'C')
        xpom=35.833
        do 1200i=1,3
          if(i.eq.1) then
            t80='P%oisson'
          else if(i.eq.2) then
            t80='%Equivalents'
          else
            t80='%Maximum'
          endif
          call FeQuestCrwMake(id,xpom,10,xpom-4.,11,t80,'C',CrwgXd,
     1                        CrwgYd,0,3)
          call FeQuestCrwOpen(8+i,i.eq.isigm)
          xpom=xpom+71.667
1200    continue
        ncsp=1
        do 1300i=1,NPhase
          ncsp=max(ncsp,ncsArr(i))
1300    continue
        if(ncsp.ne.1) then
          call FeQuestCrwMake(id,122.,5,202.,5,'Add ce%nter of symmetry'
     1                       ,'L',CrwXd,CrwYd,0,0)
          call FeQuestCrwOpen(12,.false.)
        endif
        call FeQuestLineMake(id,12)
        icont=0
1500    call FeQuestEvent(id,icont,ich)
        icont=1
        if(CheckType.eq.EventCrw) then
          if(CheckNumber.le.3) then
            if(iz.ne.CheckNumber) then
              call FeQuestCrwClose(CheckNumber+3)
              call FeQuestCrwOpen(iz+3,ix.eq.CheckNumber)
              if(ix.eq.CheckNumber) ix=iz
              iz=CheckNumber
            endif
          else if(CheckNumber.le.6) then
            ix=CheckNumber-3
          else if(CheckNumber.le.7) then
            if(CrwLogicQuest(CheckNumber)) then
              call FeQuestEdwClose(1)
              call FeQuestRealFromEdw(1,flimp)
              flim=-1.
            else
              flim=flimp
              call FeQuestRealEdwOpen(1,flim,.false.,.false.)
            endif
          else if(CheckNumber.le.8) then
            if(CrwLogicQuest(CheckNumber)) then
              fcull=fcullp
              call FeQuestRealEdwOpen(2,fcull,.false.,.false.)
            else
              call FeQuestEdwClose(2)
              call FeQuestRealFromEdw(2,fcullp)
              fcull=-1.
            endif
          endif
          EventType=EventEdw
          EventNumber=1
          go to 1500
        else if(CheckType.ne.0) then
          call NebylOsetren
          go to 1500
        endif
        if(ich.eq.0) then
          if(flim .ge.0.) call FeQuestRealFromEdw(1,flim)
          if(fcull.ge.0.) call FeQuestRealFromEdw(2,fcull)
          do 1550i=9,11
            if(CrwLogicQuest(i)) then
              isigm=i-8
              go to 1560
            endif
1550      continue
1560      if(ncsp.ne.1.and.CrwLogicQuest(12)) ncsp=1
        endif
        call FeQuestRemove(id)
        if(ich.ne.0) then
          flim=flimo
          fcull=fcullo
          go to 9999
        endif
        itr(3)=ix
        itr(1)=iz
        itr(2)=6-itr(1)-itr(3)
        do 2000i=4,ndim
          itr(i)=i
2000    continue
        do 2400KPh=1,NPhase
          call RestorePhase(KPh)
          do 2300i=1,ns
            do 2200j=1,ndim
              do 2100k=1,ndim
                mp(k+ndim*(j-1))=mr6(k+ndim*(itr(j)-1),i,1,KPh)
2100          continue
2200        continue
            call CopyMatI(mp,mr6(1,i,1,KPh),ndim)
2300      continue
2400    continue
        izp=0
        if(ncsp.ne.ncs) then
          call NewLn(2)
          write(lst,'(''Center of symmetry will be applied even if '',
     1                ''the space group is acentric'')')
          write(lst,FormA1)
        endif
        call NewLn(2)
        if(flim.ne.0.) then
          if(flim.gt.0.) then
            write(lst,'(''Only reflections |I-I(ave)|>'',f5.1,
     1                  ''*sig(I(ave)) will be printed'')') flim
            write(lst,FormA1)
          else
            write(lst,'(''Full print averaged reflections'')')
            write(lst,FormA1)
          endif
          call newln(5)
          write(lst,'(''Symbol *    means that for this reflection '',
     1                '' 3*sig<|I(i)-I(ave)|< 5*sig(I(ave))''/
     2                ''Symbol **   means that for this reflection '',
     3                '' 5*sig<|I(k)-I(ave)|<10*sig(I(ave))''/
     4                ''Symbol ***  means that for this reflection '',
     5                ''10*sig<|I(k)-I(ave)|<20*sig(I(ave))''/
     6                ''Symbol **** means that for this reflection '',
     7                ''20*sig(I(ave))<|I(k)-I(ave)|'')')
          write(lst,FormA1)
        else
          write(lst,'(''Print averaged reflections suppressed'')')
          write(lst,FormA1)
        endif
        if(fcull.gt.0.) then
          call NewLn(2)
          write(lst,'(''Reflections |I-I(ave)|>'',f5.1,
     1                ''*sig(I(ave)) will be culled'')') fcull
          write(lst,FormA1)
        endif
        if(fcull.gt.0.) then
          ncull=0
        else
          ncull=-1
        endif
        return
      endif
      n=0
      do 2810i=1,6
        ihmax(i) =0
        ihmaxp(i)=0
2810  continue
      rewind 90
      call RestorePhase(1)
3000  read(90,format91)(ih(i),i=1,ndim),ri,rs,iq,nxx,itw,tbar
      if(ih(1).gt.900) go to 3200
      call FeFlowChartEvent(izp,ie)
      if(ie.ne.0) then
        call FeBudeBreak
        if(ErrJana.ne.0) go to 9000
      endif
      if(iq.ne.kiq.or.itw.ne.kitw) go to 3000
      n=n+1
      if(n.gt.mxref) go to 8100
      do 3030i=1,ndim
        ihmax(i)=max(ihmax(i),iabs(ih(i)))
3030  continue
      fia(n)=ri
      sigfia(n)=rs
      tp(n)=tbar
      do 3100i=1,ns
        call GetSymIndRespectTwin(ih,ihp,itr,kitw,i,ncsp,ichp)
        if(ichp.ne.0) go to 3100
        do 3050j=1,ndim
          ihmaxp(j)=max(ihmaxp(j),iabs(ihp(j)))
3050    continue
3100  continue
      go to 3000
3200  if(n.le.0) return
      rewind 90
      n=0
      maxi(6)=1
      do 3220i=5,1,-1
        maxi(i)=maxi(i+1)*(2*ihmax(i+1)+1)
        if(imax/maxi(i).lt.2*ihmax(i)+1) go to 8000
3220  continue
      maxip(6)=1
      do 3225i=5,1,-1
        maxip(i)=maxip(i+1)*(2*ihmaxp(i+1)+1)
        if(imax/maxip(i).lt.2*ihmaxp(i)+1) go to 8000
3225  continue
3300  read(90,format91)(ih(i),i=1,ndim),ri,rs,iq,nxx,itw,tbar
      if(ih(1).gt.900) go to 3500
      call FeFlowChartEvent(izp,ie)
      if(ie.ne.0) then
        call FeBudeBreak
        if(ErrJana.ne.0) go to 9000
      endif
      if(iq.ne.kiq.or.itw.ne.kitw) go to 3300
      n=n+1
      mx=0
      do 3330i=1,ndim
        mx=mx+(ih(i)+ihmax(i))*maxi(i)
3330  continue
      irec(n)=mx
      mx=0
      do 3400i=1,ns
        do 3360j=1,3-min(ncs,ncsp)
          if(j.eq.1) then
            call GetSymIndRespectTwin(ih,ihp,itr,kitw,i,ncsp,ichp)
            if(ichp.ne.0) go to 3360
          else
            call GetSymIndRespectTwin(ih,ihp,itr,kitw,-i,ncsp,ichp)
            if(ichp.ne.0) go to 3360
          endif
          mxq=0
          do 3350k=1,ndim
            mxq=mxq+(ihp(k)+ihmaxp(k))*maxip(k)
3350      continue
          if(mxq.gt.mx) mx=mxq
3360    continue
3400  continue
      irecp(n)=mx
      go to 3300
3500  call indexx(n,irecp,ipor)
      lines=line
      if(ndim.eq.3) then
        mxln=mxl34-(line-3)*4
      else
        mxln=mxl34-(line-3)*3
      endif
      Psal=.false.
      line=0
      kolik=1
      kk=0
4000  call SetIntArrayTo(icull,mxgrav,0)
      lcull=.false.
4020  kp=kk+1
      if(kp.gt.n.or.ipor(kp).le.0) go to 5000
      s1=0.
      s2=0.
      s4=0.
      s5=0.
      m=0
      kkold=kk
      kolikold=kolik
      j=ipor(kp)
      ippj=irecp(j)
4100  m=m+1
      if(m.gt.mxgrav) go to 4105
      if(icull(m).eq.0) then
        s1=s1+fia(j)
        s2=s2+1.
        s4=s4+sigfia(j)**2
        s5=s5+tp(j)
      endif
4105  if(kolik.lt.n) then
        kolik=kolik+1
        j=ipor(kolik)
        if(irecp(j).eq.ippj) go to 4100
      endif
      j=ipor(kp)
      l=irecp(j)
      do 4110ii=1,ndim
        k=itr(ii)
        if(ii.eq.1) then
          ihp(k)=l/maxip(ii)-ihmaxp(ii)
        else
          ihp(k)=mod(l,maxip(ii-1))/maxip(ii)-ihmaxp(ii)
        endif
4110  continue
      kk=kp+m-1
      kkp=min(kp+mxgrav-1,kk)
      if(s2.gt.1.5) then
        s1=s1/s2
        s4=sqrt(s4)/s2
        s5=s5/s2
        s3=0.
        prumer=.true.
        i=0
        do 4220k=kp,kkp
          i=i+1
          if(icull(i).ne.0) go to 4220
          j=ipor(k)
          dif=abs(fia(j)-s1)
          s3=s3+dif**2
4220    continue
        pom=sqrt(s3/(s2*(s2-1.)))
        if(isigm.eq.1) then
          s3=s4
        else if(isigm.eq.2) then
          s4=s4*.5
          if(pom.lt.s4) then
            s3=s4
          else
            s3=pom
          endif
        else
          s3=max(pom,s4)
        endif
        tisk=.false.
        difmax=0.
        i=0
        do 4224k=kp,kkp
          i=i+1
          if(icull(i).ne.0) go to 4224
          j=ipor(k)
          dif=abs(fia(j)-s1)
          tisk=tisk.or.(dif.gt.flim*s3)
          dif=dif/s3
          if(dif.gt.difmax) then
            difmax=max(difmax,dif)
            kmax=i
          endif
4224    continue
        if(fcull.gt.0..and.difmax.gt.fcull.and.s2.gt.2.5) then
          icull(kmax)=1
          kk=kkold
          kolik=kolikold
          lcull=.true.
          ncull=ncull+1
          go to 4020
        endif
        if(tisk.or.lcull.or.flim.lt.0.) then
          line=line+1
          write(iven(line),FormRefAve)(ihp(k),k=1,ndim),s1,s3,'    '
          do 4241k=1,4
            if(iven(line)(k:k).eq.' ') iven(line)(k:k)='>'
4241      continue
          if(line.eq.mxln) then
            call EM9OutSta(iven)
            call newpg(0)
            line=0
            Psal=.true.
            mxln=mxl34
          endif
          i=0
          do 4250k=kp,kkp
            i=i+1
            j=ipor(k)
            pom=abs(fia(j)-s1)/s3
            if(icull(i).ne.0) then
              iven1='Cull'
            else if(pom.le.3.) then
              iven1=' '
            else if(pom.le.5.) then
              iven1='*'
            else if(pom.le.10.) then
              iven1='**'
            else if(pom.le.20.) then
              iven1='***'
            else
              iven1='****'
            endif
            l=irec(j)
            do 4245ii=1,ndim
              if(ii.eq.1) then
                ih(ii)=l/maxi(ii)-ihmax(ii)
              else
                ih(ii)=mod(l,maxi(ii-1))/maxi(ii)-ihmax(ii)
              endif
4245        continue
            line=line+1
            write(iven(line),FormRefAve)(ih(l),l=1,ndim),fia(j),
     1                                   sigfia(j),iven1
            if(line.eq.mxln) then
              Psal=.true.
              call EM9OutSta(iven)
              call newpg(0)
              line=0
              mxln=mxl34
            endif
4250      continue
          line=line+1
          iven(line)=' '
          if(line.eq.mxln) then
            Psal=.true.
            call EM9OutSta(iven)
            call newpg(0)
            line=0
            mxln=mxl34
          endif
        endif
      else
        s1=fia(j)
        s3=sigfia(j)
        s5=tp(j)
      endif
      mm=EM9SortIndex(ihp)
      if(s2.gt.1.5) then
        i=0
        nr=kkp-kp+1
        do 4500k=kp,kkp
          i=i+1
          j=ipor(k)
          pom=fia(j)
          nrefi(mm)=nrefi(mm)+1
          if(anint(pom*10.).gt.EM9ObsLim*anint(sigfia(j)*10.))
     1       norefi(mm)=norefi(mm)+1
          if(icull(i).ne.0) go to 4500
          apom=abs(pom-s1)
          rnum(1)=rnum(1)+apom
          rden(1)=rden(1)+pom
          if(anint(s1*10.).gt.EM9ObsLim*anint(s3*10.)) then
            ronum(1)=ronum(1)+apom
            roden(1)=roden(1)+pom
          endif
          if(ndimi.gt.0) then
            mmMax=max(mm,mmMax)
            rnum(mm)=rnum(mm)+apom
            rden(mm)=rden(mm)+pom
            if(k.eq.kp) nrefa(mm)=nrefa(mm)+1
            if(anint(s1*10.).gt.EM9ObsLim*anint(s3*10.)) then
              ronum(mm)=ronum(mm)+apom
              roden(mm)=roden(mm)+pom
              if(k.eq.kp) norefa(mm)=norefa(mm)+1
            endif
          endif
4500    continue
      else
        if(ndimi.gt.0) then
          nrefa(mm)=nrefa(mm)+1
          nrefi(mm)=nrefi(mm)+1
          if(anint(s1*10.).gt.EM9ObsLim*anint(s3*10.)) then
            norefa(mm)=norefa(mm)+1
            norefi(mm)=norefi(mm)+1
          endif
        endif
      endif
      if(ndimi.gt.0) then
        resdnum(mm)=resdnum(mm)+s3
        resdden(mm)=resdden(mm)+s1
        if(anint(s1*10.).gt.EM9ObsLim*anint(s3*10.)) then
          roesdnum(mm)=roesdnum(mm)+s3
          roesdden(mm)=roesdden(mm)+s1
        endif
      endif
      write(91,format91)(ihp(k),k=1,ndim),s1,s3,kiq,nxx,kitw,s5
      go to 4000
5000  if(line.gt.0) then
        i=line
        call EM9OutSta(iven)
        if(ndim.eq.3) then
          if(mxln.eq.mxl34) then
            line=(i-1)/4+6
          else
            line=lines+(i-1)/4+3
          endif
        else
          if(mxln.eq.mxl34) then
            line=(i-1)/3+6
          else
            line=lines+(i-1)/3+3
          endif
        endif
      else
        if(Psal) then
          line=3
        else
          line=lines
        endif
      endif
      return
8000  call FeChybne(-1.,-1.,'diffraction indices are too large to be '//
     1              'sorted and averaged',' ',0,SeriousError)
      go to 9000
8100  write(Cislo,FormI15) mxref
      call Zhusti(Cislo)
      call FeChybne(-1.,-1.,'the number of reflections exceeds the '//
     1              'limit '//Cislo,' ',0,SeriousError)
      go to 9000
9000  ich=1
      ErrJana=0
9999  return
102   format(i1)
106   format(i2)
      end
      subroutine EM9OutStA(iven)
      include 'params.cmn'
      include 'basic.cmn'
      include 'editm9.cmn'
      character*42 iven(*)
      if(line.gt.0) then
        write(lst,FormLabAve)
        if(ndim.gt.3) then
          n=(line-1)/3+1
        else
          n=(line-1)/4+1
        endif
        do 1000i=1,n
          if(ndim.gt.3) then
            write(lst,'(3a42)')(iven(i+(j-1)*n),j=1,3)
          else
            write(lst,'(4a32)')(iven(i+(j-1)*n)(1:32),j=1,4)
          endif
1000    continue
        do 2000i=1,line
          iven(line)=' '
2000    continue
        line=mxline
      endif
      return
      end
      subroutine EM9MakeScales(kiq,klic,ich)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      include 'editm9.cmn'
      include 'datred.cmn'
      dimension maxi(6),fp(mxref)
      character*80 t80
      equivalence (fia,fp)
      save iz,nn
      data flim/10./
      ich=0
      if(Klic.eq.0) then
        call FeGetILevel('Determination of the common scale(s)',
     1                   'Reflections I>',
     2                   '*sig(I) will be used in the process',' ',
     3                   flim,ich)
        if(ich.ne.0) go to 9999
        do 1000i=1,6
          itr(i)=i
1000    continue
        call TwinSym(ns,ncs,itwin,0)
        iz=0
      else if(klic.eq.1) then
        nn=0
        m=0
        do 2810i=1,6
          ihmax(i)=0
2810    continue
        rewind 90
3000    read(90,format91)(ih(i),i=1,ndim),ri,rs,iq,nxx,itw,tbar
        if(ih(1).gt.900) go to 3200
        iatw=iabs(itw)
        call FeFlowChartEvent(iz,ie)
        if(ie.ne.0) then
          call FeBudeBreak
          if(ErrJana.ne.0) go to 9000
        endif
        do 3100i=1,ns
          if(.not.BratSym(i)) go to 3100
          call multmi(ih,mr6(1,i,1,KPhase),ihp,1,ndim,ndim)
          do 3050j=1,ndim
            ihmax(j)=max(ihmax(j),iabs(ihp(j)))
3050      continue
3100    continue
        if(iq.ne.1) go to 3000
        m=m+1
        if(ri.lt.flim*rs) go to 3000
        nn=nn+1
        fia(nn)=ri
        sigfia(nn)=rs
        irecp(nn)=iatw
        go to 3000
3200    rewind 90
        scref(1)=m
        if(nn.lt.5) then
          t80='It concerns the data set #1'
          call FeChybne(-1.,-1.,'the number of common reflections '//
     1                          'less than 5',t80,0,SeriousError)
          ich=1
          go to 9999
        endif
        maxi(6)=1
        do 3220i=5,1,-1
          maxi(i)=maxi(i+1)*(2*ihmax(i+1)+1)
          if(imax/maxi(i).lt.2*ihmax(i)+1) go to 8000
3220    continue
        n=0
3300    read(90,format91)(ih(i),i=1,ndim),ri,rs,iq,nxx,itw,tbar
        if(ih(1).gt.900) go to 9999
        iatw=iabs(itw)
        call FeFlowChartEvent(iz,ie)
        if(ie.ne.0) then
          call FeBudeBreak
          if(ErrJana.ne.0) go to 9000
        endif
        if(iq.ne.1.or.ri.lt.flim*rs) go to 3300
        n=n+1
        mx=0
        do 3330i=1,ndim
          mx=mx+(ih(i)+ihmax(i))*maxi(i)
3330    continue
        irec(n)=mx
        go to 3300
      else if(Klic.eq.2) then
        rewind 90
        n=0
        m=0
        swt=0.
        srel=0.
        srelq=0.
4000    read(90,format91)(ih(i),i=1,ndim),ri,rs,iq,nxx,itw,tbar
        if(ih(1).gt.900) then
          if(m.lt.5) then
            t80='It concerns the data set #'
            write(t80(27:28),'(i2)') kiq
            if(kiq.lt.10) t80(27:)=t80(28:)
            call FeChybne(-1.,-1.,'the number of common reflections '//
     1                            'less than 5',t80,0,SeriousError)
            ich=1
          else
            sckor(kiq)=srel/swt
            sckors(kiq)=sqrt((srelq-srel**2/swt)/(float(m-1)*swt))
            sccom(kiq)=m
            scref(kiq)=n
          endif
          go to 9999
        endif
        iatw=iabs(itw)
        call FeFlowChartEvent(iz,ie)
        if(ie.ne.0) then
          call FeBudeBreak
          if(ErrJana.ne.0) go to 9000
        endif
        if(iq.ne.kiq) go to 4000
        n=n+1
        if(ri.lt.flim*rs) go to 4000
        do 4100i=1,ns
          if(.not.BratSym(i)) go to 4100
          call multmi(ih,mr6(1,i,1,KPhase),ihp,1,ndim,ndim)
          mx=0
          do 4030j=1,ndim
            mx=mx+(ihp(j)+ihmax(j))*maxi(j)
4030      continue
          do 4040j=1,nn
            if(mx.eq.irec(j).and.iatw.eq.irecp(j)) then
              m=m+1
              rel=fia(j)/ri
              wt=1./(rel**2*((sigfia(j)/fia(j))**2+(rs/ri)**2))
              srel=srel+wt*rel
              srelq=srelq+wt*rel**2
              swt=swt+wt
              go to 4000
            endif
4040      continue
4100    continue
        go to 4000
      else if(Klic.eq.3) then
        rewind 90
        in=0
5000    read(90,format91)(ih(i),i=1,ndim),ri,rs,iq,nxx,itw,tbar
        if(ih(1).gt.900) then
          write(91,'('' 999'')')
          call heap(in,fp)
          fmez(8)=fp(in)+.1
          d=0.
          dd=float(in)*.125
          do 5500i=1,7
            d=d+dd
            j=d
            fmez(i)=(fp(j)+fp(j+1))*.5
5500      continue
          go to 9999
        endif
        iatw=iabs(itw)
        call FeFlowChartEvent(iz,ie)
        if(ie.ne.0) then
          call FeBudeBreak
          if(ErrJana.ne.0) go to 9000
        endif
        if(iq.ne.1) then
          ri=ri*sckor(iq)
          rs=rs*sckor(iq)
          iq=1
        endif
        if(anint(ri*10.).gt.EM9ObsLim*anint(rs*10.)) then
          in=in+1
          fp(in)=ri
        endif
        write(91,format91)(ih(i),i=1,ndim),ri,rs,iq,nxx,itw,tbar
        go to 5000
      endif
      go to 9999
8000  call FeChybne(-1.,-1.,'diffraction indices are too large to be '//
     1              'sorted',' ',0,SeriousError)
      ich=2
      go to 9999
9000  ich=1
      ErrJana=0
9999  return
      end
      subroutine ImportReflections
      parameter (MaxImp=10)
      include 'params.cmn'
      include 'basic.cmn'
      include 'editm9.cmn'
      include 'datred.cmn'
      include 'fepc.cmn'
      dimension TrmIn(36,MaxImp),TrmInk(36),ndim95(MaxImp),nsupk(3),
     1          nsup(3,MaxImp),iq(MaxImp),TypeIn(MaxImp),ln(MaxImp),
     2          itw(MaxImp),mmax(MaxImp),nrefp(MaxImp),nrefk(MaxImp),
     3          nrefd(MaxImp),difi(3,MaxImp),difik(3),qp(3),
     4          RscFak(MaxImp)
      character*256 FileIn(MaxImp),FileIn94(MaxImp),FileInk,FileIn94k,
     1              t256
      character*128 t128
      character*80 FormatIn(MaxImp),FormatInk,t80,p80
      integer TypeIn,TypeInk
      logical TrInd(MaxImp),TrIndk,FeYesNo,Change,eqrv,SelwLogicQuest,
     1        ExistFile
      if(ExistM94) then
        call iom94(0)
        call iom50(0,0)
      else
        call SetBasicM94
      endif
      nopened=0
      if(itwin.le.1) then
        TwType=0
      else
        TwType=1
      endif
      do 1090it=2,itwin
        do 1050i=1,9
          pom=rtw(i,it)
          if(abs(pom-anint(pom)).lt..001) then
            go to 1050
          else
            TwType=2
            den=2.
1040        pomt=pom*den
            if(abs(pomt-anint(pomt)).lt..001) go to 1050
            den=den+1.
            if(den.lt.9.99) go to 1040
            TwType=3
            go to 1100
          endif
1050    continue
        do 1060i=1,ndimi
          call multm(qu(1,i,1,KPhase),rtw(1,it),qp,1,3,3)
          call od0do1(qp,qp,3)
          if(.not.eqrv(qu(1,i,1,KPhase),qp,3,.0001)) then
            TwType=3
            go to 1100
          endif
1060    continue
1090  continue
1100  Change=.false.
      n=0
      t80=fln(:ifln)//'.m95'
      if(.not.ExistFile(t80)) then
        k=1
        ib=0
        go to 2600
      endif
      call OpenFile(95,t80,'formatted','old')
      if(ErrJana.ne.0) go to 9500
      call PrvniM95(ich)
      if(ich.ne.0) go to 9500
      rewind 95
      read(95,FormA80,err=9300) p80
      t80=p80
      call Mala(t80)
      if(t80.eq.ImportTextB) then
1200    read(95,FormA80,err=9300) t256
        t80=t256
        call mala(t80)
        if(t80.eq.ImportTextE) go to 1400
        n=n+1
        if(n.eq.1) then
          nrefp(1)=1
        else
          nrefp(n)=nrefk(n-1)+1
        endif
        FileIn(n)=t256
        FileIn94(n)=' '
1210    read(95,FormA80,err=9300) t256
        if(t256.eq.' ') go to 1210
        read(t256,102,err=1220) TypeIn(n),ndim95(n),iq(n),itw(n),
     1                          mmax(n),TrInd(n),(nsup(i,n),i=1,3),
     2                          (difi(i,n),i=1,3),RscFak(n)
        go to 1230
1220    FileIn94(n)=t256
        go to 1210
1230    if(RscFak(n).le.0.) RscFak(n)=1.
        pom=0.
        do 1250i=1,3
          pom=pom+abs(difi(i,n))
1250    continue
        if(pom.lt..001) then
          do 1260i=1,3
            difi(i,n)=.01
1260      continue
        endif
        do 1300i=1,ndim95(n)
          read(95,101,err=9300)(TrmIn(i+(j-1)*ndim95(n),n),
     1                                                  j=1,ndim95(n))
1300    continue
        read(95,FormA80,err=9300) FormatIn(n)
        if(TypeIn(n).eq.5) FormatIn(n)=FormatIn(n)(:5)//Format95(6:)
        read(95,103,err=9300) nrefd(n)
        nrefk(n)=nrefp(n)+nrefd(n)-1
        go to 1200
1400    nn=2*nrefk(n)
        call FeFlowChartOpen(-1.,-1.,max(nint(float(nn)*.005),10),nn,
     1                       'Preparing temporary files',' ',' ')
        iz=0
        do 1500i=1,n
          call EM9NewImpFile(ln(i))
          if(ErrJana.ne.0) go to 9200
          nopened=i
          do 1450j=1,2*nrefd(i)
            read(95,FormA128,err=9300) t128
            write(ln(i),FormA1)(t128(k:k),k=1,idel(t128))
            call FeFlowChartEvent(iz,ie)
            if(ie.ne.0) then
              call FeBudeBreak
              if(ErrJana.ne.0) go to 9200
            endif
1450      continue
1500    continue
        call FeFlowChartRemove
        call CloseIfOpened(95)
      endif
      k=1
2000  id=NextQuestId()
      ib=0
      call FeQuestCreate(id,-1.,-1.,210.,n+1,1,'Import file',0,
     1                   LightGray,0,0)
      xpom=25.
      do 2050i=1,3
        if(i.eq.1) then
          t80='%Re-import'
        else if(i.eq.2) then
          t80='%Delete'
        else
          t80='%New file'
        endif
        call FeQuestButtonMake(id,xpom,n+2,40.,ButYd,t80)
        call FeQuestButtonOpen(i+2,ButtonOff)
        xpom=xpom+60.
2050  continue
      if(n.gt.0) then
        xpom=7.5+SmallFontWidth*18.
        call FeQuestLabelMake(id,xpom,1,'file','C')
        xpom=xpom+SmallFontWidth*24.
        call FeQuestLabelMake(id,xpom,1,'from','C')
        xpom=xpom+SmallFontWidth*9.
        call FeQuestLabelMake(id,xpom,1,'to','C')
        do 2100i=1,n
          j=idel(FileIn(i))
          if(j.gt.34) then
            t80='...'//FileIn(i)(j-30:j)
          else
            t80=FileIn(i)
          endif
          write(t80(37:),'('' | '',i6,'' | '',i6,'' | '')') nrefp(i),
     1                                                      nrefk(i)
          call FeQuestSelwMake(id,5.,i+1,t80,200.,SelwYd,0,1)
          call FeQuestSelwOpen(SelwTo-SelwFr+1,i.eq.k)
2100    continue
      else
        call FeQuestButtonDisable(3)
        call FeQuestButtonDisable(4)
      endif
2200  icont=0
2250  call FeQuestEvent(id,icont,ich)
      icont=1
      if(CheckType.eq.EventButton.and.CheckNumber.le.5) then
        ib=CheckNumber-2
        EventType=EventButton
        EventNumber=2
        go to 2250
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 2250
      endif
      if(ich.eq.0) then
        if(ib.eq.0) then
          go to 2340
        else if(ib.le.2) then
          do 2300i=1,n
            if(SelwLogicQuest(i)) then
              k=i
              call FeQuestRemove(id)
              if(ib.eq.1) then
                go to 3000
              else
                go to 2350
              endif
            endif
2300      continue
        else
          k=n+1
          call FeQuestRemove(id)
          go to 2600
        endif
      endif
2340  call FeQuestRemove(id)
      go to 9000
2350  close(ln(k),status='delete')
      do 2400i=k+1,n
        ln(i-1)=ln(i)
        if(i.eq.2) then
          nrefp(i-1)=1
        else
          nrefp(i-1)=nrefk(i-2)+1
        endif
        iq(i-1)=iq(i)
        itw(i-1)=itw(i)
        mmax(i-1)=mmax(i)
        FileIn(i-1)=FileIn(i)
        FileIn94(i-1)=FileIn94(i)
        FormatIn(i-1)=FormatIn(i)
        TypeIn(i-1)=TypeIn(i)
        ndim95(i-1)=ndim95(i)
        RscFak(i-1)=RscFak(i)
        call CopyVekI(nsup(1,i),nsup(1,i-1),3)
        call CopyVek(difi(1,i),difi(1,i-1),3)
        TrInd(i-1)=TrInd(i)
        call CopyMat(TrmIn(1,i),TrmIn(1,i-1),ndim95(i))
        nrefd(i-1)=nrefd(i)
        nrefk(i-1)=nrefp(i-1)+nrefd(i-1)-1
2400  continue
      n=n-1
      Change=.true.
      go to 2000
2600  if(k.eq.1) then
        iq(1)=1
        itw(1)=1
        mmax(1)=4
        TypeIn(1)=5
        ndim95(1)=3
        RscFak(1)=1.
        do 2700i=1,3
          nsup(i,1)=1
2700    continue
        do 2800i=1,3
          difi(i,1)=.01
2800    continue
        TrInd(1)=.false.
        FileIn(1)='.m95'
        FileIn94(1)=' '
        FormatIn(1)='(3i4,2f10.2)'
        call unitmat(TrmIn,ndim95(1))
      else if(k.le.MaxImp) then
        iq(k)=iq(k-1)
        itw(k)=itw(k-1)
        mmax(k)=mmax(k-1)
        TypeIn(k)=TypeIn(k-1)
        ndim95(k)=ndim95(k-1)
        RscFak(k)=1.
        call CopyVekI(nsup(1,k-1),nsup(1,k),3)
        call CopyVek(difi(1,k-1),difi(1,k),3)
        TrInd(k)=TrInd(k-1)
        call CopyMat(TrmIn(1,k-1),TrmIn(1,k),ndim95(k))
        i=idel(FileIn(k-1))
        FileIn(k)='.'//FileIn(k-1)(i-2:i)
        FileIn94(k)=' '
        FormatIn(k)=FormatIn(k-1)
      else
        write(t80,'(i2)') MaxImp
        call FeChybne(-1.,-1.,'the maximun number of imported files '//
     1                t80(:2)//' reached',' ',0,SeriousError)
        go to 2000
      endif
      call EM9NewImpFile(ln(k))
      if(ErrJana.ne.0) go to 9200
3000  nref=0
      lnk=ln(k)
      FileInk=FileIn(k)
      FileIn94k=FileIn94(k)
      FormatInk=FormatIn(k)
      TypeInk=TypeIn(k)
      ndim95k=ndim95(k)
      iqk=iq(k)
      itwk=itw(k)
      mmaxk=mmax(k)
      RscFakk=RscFak(k)
      call CopyVekI(nsup(1,k),nsupk,3)
      call CopyVek(difi(1,k),difik,3)
      TrIndk=TrInd(k)
      call CopyMat(TrmIn(1,k),TrmInk,ndim95k)
      call EM9ImportFile(lnk,FileInk,FileIn94k,FormatInk,TypeInk,
     1                   ndim95k,iqk,itwk,mmaxk,nsupk,difik,RscFakk,
     2                   TrIndk,TrmInk,nref,ich)
      if(ich.eq.0) then
        Change=.true.
        ln(k)=lnk
        FileIn(k)=FileInk
        FileIn94(k)=FileIn94k
        FormatIn(k)=FormatInk
        TypeIn(k)=TypeInk
        ndim95(k)=ndim95k
        iq(k)=iqk
        itw(k)=itwk
        mmax(k)=mmaxk
        RscFak(k)=RscFakk
        call CopyVekI(nsupk,nsup(1,k),3)
        call CopyVek(difik,difi(1,k),3)
        TrInd(k)=TrIndk
        call CopyMat(TrmInk,TrmIn(1,k),ndim95k)
        nrefd(k)=nref
        if(k.gt.n) n=k
        do 3100i=1,n
          if(i.eq.1) then
            nrefp(1)=1
          else
            nrefp(i)=nrefk(i-1)+1
          endif
          nrefk(i)=nrefp(i)+nrefd(i)-1
3100    continue
      else
        if(ib.eq.3) close(ln(k),status='delete')
        if(n.eq.0) go to 9999
        k=n
      endif
      go to 2000
9000  if(Change) then
        if(ich.eq.0) then
          if(FeYesNo(-1.,-1.,'Do you want to accept the made changes?',
     1               1)) then
            go to 9100
          else
            go to 9200
          endif
        else
          if(FeYesNo(-1.,-1.,'Do you want to avoid the made changes?',
     1               1)) then
            go to 9200
          else
            go to 9100
          endif
        endif
      endif
      go to 9200
9100  call OpenFile(95,fln(:ifln)//'.m95','formatted','unknown')
      if(ErrJana.ne.0) go to 9500
      if(n.gt.0) then
        write(95,FormA1)(ImportTextB(i:i),i=1,idel(ImportTextB))
        do 9140k=1,n
          write(95,FormA1)(FileIn(k)(i:i),i=1,idel(FileIn(k)))
          if(TypeIn(k).eq.5)
     1      write(95,FormA1)(FileIn94(k)(i:i),i=1,idel(FileIn94(k)))
          write(95,102) TypeIn(k),ndim95(k),iq(k),itw(k),mmax(k),
     1                  TrInd(k),(nsup(i,k),i=1,3),(difi(i,k),i=1,3),
     2                  RscFak(k)
          do 9120i=1,ndim95(k)
            write(95,101)(TrmIn(i+(j-1)*ndim95(k),k),j=1,ndim95(k))
9120      continue
          write(95,FormA1)(FormatIn(k)(i:i),i=1,idel(FormatIn(k)))
          write(95,103) nrefd(k)
9140    continue
        write(95,FormA1)(ImportTextE(i:i),i=1,idel(ImportTextE))
        nn=2*nrefk(n)
        call FeFlowChartOpen(-1.,-1.,max(nint(float(nn)*.005),10),nn,
     1                       'Merging temporary files',' ',' ')
        iz=0
        do 9180i=1,n
          rewind ln(i)
          do 9160j=1,2*nrefd(i)
            read(ln(i),FormA128) t128
            write(95,FormA1)(t128(k:k),k=1,idel(t128))
            call FeFlowChartEvent(iz,ie)
            if(ie.ne.0)
     1        call FeMsgOut(-1.,30.,'The action cannot be canceled!')
9160      continue
9180    continue
        call FeFlowChartRemove
        call CloseIfOpened(95)
        nref95=nrefk(n)
      else
        nref95=0
        close(95,status='delete')
      endif
      call iom94(1)
      if(FeYesNo(-1.,-1.,'Do you want to create refinement reflection'//
     1           ' file (m91)?',1)) call ExportM91
9200  do 9220i=1,nopened
        close(ln(i),status='delete')
9220  continue
      go to 9500
9300  call FeReadError(95)
9500  call CloseIfOpened(95)
9999  return
101   format(6f10.6)
102   format(5i5,l5,3i5,3f8.3,f10.5)
103   format(i10)
      end
      subroutine EM9ImportFile(ln,FileIn,FileIn94,FormatIn,TypeIn,
     1                         ndim95,iq,itwi,mmax,nsup,difi,RscFak,
     2                         TransformIndices,TrmIn,nrefp,ich)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      include 'editm9.cmn'
      include 'datred.cmn'
      dimension h(6),hf(6),ihf(3),trm(36),trmi(36),trp(36),quit(3,3),
     1          quo(3,3),TrmIn(36),nsup(3),difi(3)
      character*(*) FileIn,FileIn94,FormatIn
      character*256 EdwStringQuest,t256
      character*80  t80,p80
      character*18  men(7)
      character*2   nty
      integer TypeIn,EdwStateQuest
      logical Fractional,TransformIndices,EqIgCase,RealIndices,
     1        NicTamNeni,FreeFormat,CrwLogicQuest
      data men/'%JANA93/94',
     1         'SHEL%X on F',
     2         '%SHELX on I',
     3         'IPDS ST%OE',
     4         '%DATRED',
     5         'General file on %F',
     6         'General file on %I'/
      call SetRealArrayTo(quit,9,0.)
      ich=0
      id=NextQuestId()
      call FeQuestCreate(id,-1.,-1.,220.,0,15,'Specify input reflection'
     1                 //' file',1,LightGray,0,0)
      il=2
      do 1010i=1,7
        il=il+1
        call FeQuestCrwMake(id,140.,il,207.,il,men(i),'L',CrwgXd,CrwgYd,
     1                      1,1)
        nCrwTypeTo=CrwLastMade
        if(i.eq.1) nCrwTypeFr=nCrwTypeTo
        call FeQuestCrwOpen(nCrwTypeTo,i.eq.TypeIn)
1010  continue
      il=1
      t80='%Reflection file'
      tpom=5.
      xpom=tpom+FeTxLength(t80)+5.
      dpom=175.-xpom
      call FeQuestEdwMake(id,tpom,il,xpom,il,t80,'L',dpom,EdwYd,1)
      nEdwRefFile=EdwLastMade
      call FeQuestButtonMake(id,180.,il,35.,ButYd,'%Browse')
      nButtRefBrowse=ButtonLastMade
      call FeQuestButtonOpen(ButtonLastMade,ButtonOff)
      il=il+1
      call FeQuestEdwMake(id,tpom,il,xpom,il,'File for%mat','L',dpom,
     1                    EdwYd,0)
      nEdwFormat=EdwLastMade
      if(TypeIn.gt.5) call FeQuestStringEdwOpen(nEdwFormat,FormatIn)
      t80='Asso%ciated file'
      call FeQuestEdwMake(id,tpom,il,xpom,il,t80,'L',dpom,EdwYd,0)
      nEdwAssFile=EdwLastMade
      call FeQuestButtonMake(id,180.,il,35.,ButYd,'Bro%wse')
      nButtAssBrowse=ButtonLastMade
      call FeQuestButtonOpen(ButtonLastMade,ButtonOff)
      il=il+1
      call FeQuestEudMake(id,5.,il,105.,il,'N%umber of indices','L',
     1                    15.,EdwYd,1)
      nEdwNdim=EdwLastMade
      call FeQuestIntEdwOpen(nEdwNdim,ndim95,.false.)
      call FeQuestEudOpen(nEdwNdim,3,6,1,0.,0.,0.)
      t80='Scal%e#'
      xpom=8.+FeTxLengthUnder(t80)
      il=il+1
      call FeQuestEudMake(id,5.,il,xpom,il,t80,'L',15.,EdwYd,0)
      nEdwScale=EdwLastMade
      call FeQuestIntEdwOpen(nEdwScale,iq,.false.)
      call FeQuestEudOpen(nEdwScale,0,mxsc,1,0.,0.,0.)
      t80='%Twin#'
      tpom=102.-FeTxLengthUnder(t80)
      call FeQuestEudMake(id,tpom,il,105.,il,t80,'L',15.,EdwYd,0)
      nEdwTwin=EdwLastMade
      t80='O%verlap'
      il=il+1
      xpom=120.-CrwXd
      call FeQuestCrwMake(id,tpom,il,xpom,il,t80,'L',CrwXd,CrwYd,0,0)
      nCrwOverlap=CrwLastMade
      if(TwType.ge.1) then
        call FeQuestIntEdwOpen(nEdwTwin,iabs(itwi),.false.)
        call FeQuestEudOpen(nEdwTwin,1,itwin,1,0.,0.,0.)
        call FeQuestCrwOpen(nCrwOverlap,itwi.gt.0)
      endif
      il=il+1
      call FeQuestEdwMake(id,5.,il,90.,il,'Su%percell','L',30.,EdwYd,0)
      nEdwScell=EdwLastMade
      il=il+1
      call FeQuestEudMake(id,5.,il,105.,il,'%Maximal satellite index',
     1                    'L',15.,EdwYd,0)
      nEdwMxSat=EdwLastMade
      il=il+1
      call FeQuestEdwMake(id,5.,il,55.,il,'%Accuracy','L',65.,EdwYd,0)
      nEdwAcc=EdwLastMade
      if(ndim.gt.ndim95) then
        call FeQuestIntAEdwOpen(nEdwScell,nsup,3,.false.)
        call FeQuestIntEdwOpen(nEdwMxSat,mmax,.false.)
        call FeQuestEudOpen(nEdwMxSat,0,99,1,0.,0.,0.)
        call FeQuestRealAEdwOpen(nEdwAcc,difi,3,.false.,.false.)
      endif
      il=il+1
      call FeQuestCrwMake(id,5.,il,70.,il,'Tra%nsform indices','L',
     1                    CrwXd,CrwYd,1,0)
      nCrwTrInd=CrwLastMade
      call FeQuestCrwOpen(nCrwTrInd,TransformIndices)
      call FeQuestLabelMake(id,85.,il,'by matrix','L')
      t80='Mu%ltiply input I/F by'
      xpom=185.-FeTxLengthUnder(t80)
      il=il+1
      call FeQuestEdwMake(id,xpom,il,190.,il,t80,'L',25.,EdwYd,0)
      nEdwRsc=EdwLastMade
      call FeQuestRealEdwOpen(nEdwRsc,RscFak,.false.,.false.)
      call TrMat(TrmIn,Trm,ndim95)
      k=1
      do 1015i=1,6
        write(t80,'(''%'',i1,a2,'' row'')') i,nty(i)
        call FeQuestEdwMake(id,5.,il,35.,il,t80,'L',65.,EdwYd,0)
        nEdw=EdwLastMade
        if(TransformIndices.and.i.le.ndim95)
     1    call FeQuestRealAEdwOpen(nEdw,Trm(k),ndim95,.false.,.true.)
        if(i.eq.1) nEdwTrMat=nEdw
        k=k+ndim95
        il=il+1
1015  continue
      if(TypeIn.eq.5) t256=FileIn94
1017  icont=0
1018  if(FileIn.eq.' ') then
        if(TypeIn.eq.1) then
          FileIn=fln(:ifln)//'.m90'
        else if(TypeIn.eq.5) then
          FileIn='.m95'
        else
          FileIn=fln(:ifln)//'.hkl'
        endif
      endif
      call FeQuestStringEdwOpen(nEdwRefFile,FileIn)
      if(TypeIn.eq.5) then
        if(FileIn94.eq.' '.or.FileIn94.eq.'.m94') then
          if(FileIn.eq.'.m95') then
            FileIn94='.m94'
          else
            i=index(FileIn,'.m95')
            if(i.le.0) then
              FileIn94=t256
            else
              FileIn94=FileIn
              if(i.gt.0) FileIn94(i:i+3)='.m94'
            endif
          endif
        endif
        call FeQuestStringEdwOpen(nEdwAssFile,FileIn94)
      endif
1020  call FeQuestEvent(id,icont,ich)
      FileIn=EdwString(nEdwRefFile)
      if(TypeIn.eq.5) then
        FileIn94=EdwString(nEdwAssFile)
        t256=FileIn94
      endif
      icont=1
      if(CheckType.eq.EventButton.and.CheckNumberAbs.eq.ButtonOK) then
        if(FileIn.ne.' ') then
          call EM9CheckFileIn(FileIn,FileIn94,TypeIn,ich)
          if(ich.ne.0) go to 1025
        endif
        if(CrwLogicQuest(nCrwTrInd)) then
          j=1
          do 1021i=1,ndim95
            call FeQuestRealAFromEdw(nEdwTrMat+i-1,Trm(j))
            j=j+ndim95
1021      continue
          call matinv(Trm,trmi,pom,ndim95)
          if(abs(pom).le..00001) then
            call FeChybne(-1.,-1.,'the matrix is singular',' ',0,
     1                    SeriousError)
            go to 1025
          else if(pom.lt.0.) then
            call FeChybne(-1.,-1.,'the matrix is non-positive '//
     1                    'definite',' ',0,SeriousError)
            go to 1025
          endif
        endif
1024    QuestCheck(id)=0
        go to 1020
1025    icont=0
        call FeButtonOff(ButtonOK)
        go to 1020
      else if(CheckType.eq.EventCrw.and.
     1        (CheckNumber.ge.nCrwTypeFr.and.CheckNumber.le.nCrwTypeTo))
     2  then
        if(TypeIn.eq.1) then
          t80=fln(:ifln)//'.m90'
        else if(TypeIn.eq.5) then
          t80='.m95'
        else
          t80=fln(:ifln)//'.hkl'
        endif
        TypeIn=CheckNumber-nCrwTypeFr+1
        if(EqIgCase(t80,EdwStringQuest(nEdwRefFile))) then
          if(TypeIn.eq.1) then
            t80=fln(:ifln)//'.m90'
          else if(TypeIn.eq.5) then
            t80='.m95'
          else
            t80=fln(:ifln)//'.hkl'
          endif
          call FeQuestStringEdwOpen(nEdwRefFile,t80)
        endif
        if(TypeIn.gt.5) then
          call FeQuestEdwClose(nEdwAssFile)
          if(EdwStateQuest(nEdwFormat).eq.EdwClosed)
     1      call FeQuestStringEdwOpen(nEdwFormat,FormatIn)
        else
          call FeQuestEdwClose(nEdwFormat)
        endif
        if(TypeIn.eq.5) then
          if(EdwStateQuest(nEdwAssFile).eq.EdwClosed) then
            call FeQuestStringEdwOpen(nEdwAssFile,FileIn94)
            call FeQuestButtonOpen(nButtAssBrowse,ButtonOff)
          endif
        else
          call FeQuestEdwClose(nEdwAssFile)
          call FeQuestButtonClose(nButtAssBrowse)
        endif
        icont=0
        go to 1020
      else if(CheckType.eq.EventCrw.and.CheckNumber.eq.nCrwTrInd) then
        if(EdwStateQuest(nEdwTrMat).eq.EdwClosed) then
          j=1
          do 1028i=1,ndim95
            call FeQuestRealAEdwOpen(nEdwTrMat+i-1,Trm(j),ndim95,
     1                               .false.,.false.)
            j=j+ndim95
1028      continue
        else
          do 1029i=nEdwTrMat,nEdwTrMat+ndim95-1
            call FeQuestEdwClose(i)
1029      continue
        endif
        icont=0
        go to 1020
      else if(CheckType.eq.EventEdw.and.CheckNumber.eq.nEdwNdim) then
        i=EdwInt(1,nEdwNdim+EdwFr-1)
        if(ndim.gt.i) then
          if(EdwStateQuest(nEdwSCell).eq.EdwClosed) then
            do 1030j=1,3
              nsup(j)=1
1030        continue
            call FeQuestIntAEdwOpen(nEdwSCell,nsup,3,.false.)
            call FeQuestIntEdwOpen(nEdwMxSat,mmax,.false.)
            call FeQuestRealAEdwOpen(nEdwAcc,difi,3,.false.,.false.)
          endif
        else
          call FeQuestEdwClose(nEdwSCell)
          call FeQuestEdwClose(nEdwMxSat)
          call FeQuestEdwClose(nEdwAcc)
        endif
        if(ndim95.ne.i) then
          ndim95=i
          call UnitMat(Trm,ndim95)
          if(CrwLogicQuest(nCrwTrInd)) then
            j=1
            do 1032i=1,6
              k=nEdwTrMat+i-1
              if(i.le.ndim95) then
                call FeQuestRealAEdwOpen(k,Trm(j),ndim95,.false.,
     1                                   .false.)
                j=j+ndim95
              else
                call FeQuestEdwClose(k)
              endif
1032        continue
          endif
        endif
        go to 1020
      else if(CheckType.eq.EventButton.and.
     1        CheckNumber.eq.nButtRefBrowse) then
        if(TypeIn.eq.1) then
          t80='*.m90'
        else if(TypeIn.eq.5) then
          i=index(FileIn,'.m95')
          if(idel(FileIn).eq.i+3) then
            t80='*.m95'
          else
            t80='*.*'
          endif
        else
          t80='*.hkl'
        endif
        if(TypeIn.eq.5) call EM9ResetAssFile(FileIn,FileIn94)
        call FeFileManager('Select reflection file',FileIn,t80,0,.true.,
     1                     ich)
        call FeQuestButtonOff(nButtRefBrowse)
        if(ich.ne.0) FileIn94=t256
        go to 1017
      else if(CheckType.eq.EventButton.and.
     1        CheckNumber.eq.nButtAssBrowse) then
        i=index(FileIn94,'.m94')
        if(idel(FileIn94).eq.i+3) then
          t80='*.m94'
        else
          t80='*.*'
        endif
        call FeFileManager('Select associated file',FileIn94,t80,0,
     1                     .true.,ich)
        call FeQuestButtonOff(nButtAssBrowse)
        go to 1017
      else if(CheckType.eq.EventEdw.and.CheckNumber.eq.nEdwRefFile) then
        if(TypeIn.eq.5) call EM9ResetAssFile(FileIn,FileIn94)
        go to 1018
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1020
      endif
      if(ich.eq.0) then
        if(TypeIn.gt.5) FormatIn=EdwStringQuest(nEdwFormat)
        call FeQuestIntFromEdw(nEdwNdim,ndim95)
        call FeQuestIntFromEdw(nEdwScale,iq)
        call FeQuestRealFromEdw(nEdwRsc,RscFak)
        if(TwType.ge.1) then
          call FeQuestIntFromEdw(nEdwTwin,itwi)
          if(.not.CrwLogicQuest(nCrwOverlap)) itwi=-itwi
        else
          itwi=1
        endif
        iatw=iabs(itwi)
        if(ndim.gt.ndim95) then
          call FeQuestIntAFromEdw(nEdwScell,nsup)
          call FeQuestIntFromEdw(nEdwMxSat,mmax)
          call FeQuestRealAFromEdw(nEdwAcc,difi)
        else
          do 1045i=1,3
            difi(i)=.001
1045      continue
        endif
        TransformIndices=CrwLogicQuest(nCrwTrInd)
        if(TransformIndices) then
          call TrMat(Trm,TrmIn,ndim95)
        else
          call UnitMat(TrmIn,ndim95)
        endif
      endif
      call FeQuestRemove(id)
      if(ich.ne.0) go to 9999
      nsups=nsup(1)+nsup(2)+nsup(3)
      Fractional=.false.
      tbar=0.
      call SetRealArrayTo(uhly,4,0.)
      call SetRealArrayTo(dircos,6,0.)
      call SetRealArrayTo(corrf,2,1.)
      if(ndim.gt.ndim95) then
        if(nsups.gt.3) then
          do 1162j=1,ndimi
            do 1160i=1,3
              quo(i,j)=qu(i,j,1,KPhase)
              pom=float(nsup(i))
              qu(i,j,1,KPhase)=anint(qu(i,j,1,KPhase)*pom)/pom
              qui(i,j,KPhase)=qu(i,j,1,KPhase)-quir(i,j,KPhase)
1160        continue
1162      continue
          if(ncomp.gt.1) call setmet(0)
          if(kcommen.ne.0.and.ndim.eq.4) call ComSym(0,0)
        endif
      else if(ndim.lt.ndim95) then
        if(itwin.le.1) then
          write(t80,FormA256) ndim
          t80='more than '//t80(1:1)//' indices indicates that '
          call FeChybne(-1.,-1.,t80,'the structure has to be twin',0,
     1                  SeriousError)
          go to 9100
        endif
        iwc=ndim95-ndim
        id=NextQuestId()
        call FeQuestCreate(id,-1.,-1.,180.,0,iwc,'Non-lattice '//
     1                     'reciprocal vectors induced by twinning',0,
     2                     LightGray,0,0)
        do 1200i=1,iwc
          write(t80,'(''%'',i1,a2,'' vector'')') i,nty(i)
          call FeQuestEdwMake(id,5.,i,60.,i,t80,'L',115.,EdwYd,0)
          NicTamNeni=abs(quit(1,i))+abs(quit(2,i))+abs(quit(3,i)).le.0.
          call FeQuestRealAEdwOpen(i,quit(1,i),3,NicTamNeni,.false.)
1200    continue
        icont=0
        call FeQuestEvent(id,icont,ich)
        icont=1
        if(ich.eq.0) then
          do 1210i=1,iwc
            call FeQuestRealAFromEdw(i,quit(1,i))
1210      continue
        endif
        call FeQuestRemove(id)
        if(ich.ne.0) go to 9999
      else
        if(itwin.gt.1) then
          if(TwType.eq.2) then
            call OpenFile(96,FileIn,'formatted','old')
            if(ErrJana.ne.0) go to 9100
            read(96,FormA80) t80
            call CloseIfOpened(96)
            call mala(t80)
            k=0
            call kus(t80,k,Cislo)
            if(Cislo.eq.'fract') then
              Fractional=.true.
              do 1330i=1,ndim
                call kus(t80,k,Cislo)
                call posun(Cislo,0)
                read(Cislo,FormI15) ihf(i)
1330          continue
            endif
          endif
        endif
      endif
      if(ndim95.eq.3.or.TypeIn.ne.4) then
        ndim95i=ndim95
      else
        ndim95i=6
      endif
      RealIndices=.false.
      FreeFormat=.false.
      if(TypeIn.lt.6) then
        FormatIn='(.i4,'
        write(FormatIn(2:2),100) ndim95i
        if(TypeIn.eq.1) then
          FormatIn=FormatIn(1:5)//'f9.1,f9.4)'
        else if(TypeIn.eq.5) then
          FormatIn=Format95
          write(FormatIn(5:5),100) ndim95i
          call OpenFile(97,FileIn94,'formatted','old')
          if(ErrJana.ne.0) go to 9100
          call UnitMat(trp,ndim95)
1440      read(97,FormA80,end=1450,err=1450) t80
          call mala(t80)
          if(index(t80,'trmat').eq.1) then
            do 1444i=1,ndim95
              read(97,FormA80,end=1450,err=1450) t80
              k=0
              call StToReal(t80,k,h,ndim95,.false.,ich)
              k=i
              do 1442j=1,ndim95
                trp(k)=h(j)
                k=k+ndim95
1442          continue
1444        continue
            go to 1460
          else
            go to 1440
          endif
          go to 1460
1450      rewind 97
          do 1451i=1,4
            read(97,'(a)')
1451      continue
          do 1452i=1,ndim95
            read(97,'(6f12.6)')(trp(i+(j-1)*ndim95),j=1,ndim95)
1452      continue
1460      call CloseIfOpened(97)
          call OpenFile(95,FileIn,'formatted','old')
          if(ErrJana.ne.0) go to 9100
          i=ndim
          if(ndim95.ne.ndim) then
            t80(1:1)=Format95(5:5)
            Format95(5:5)   =FormatIn(5:5)
            Format95old(5:5)=FormatIn(5:5)
            ndim=ndim95
          endif
          call PrvniM95(ich)
          call CloseIfOpened(95)
          if(ndim95.ne.i) then
            Format95(5:5)   =t80(1:1)
            Format95old(5:5)=t80(1:1)
            ndim=i
          endif
        else
          FormatIn=FormatIn(1:5)//'2f8.2)'
        endif
      else
        call Zhusti(FormatIn)
        call mala(FormatIn)
        if(FormatIn.eq.'*'.or.FormatIn.eq.'(*)') then
          FreeFormat=.true.
        else
          i=index(FormatIn,'i')
          j=max(index(FormatIn,'f'),index(FormatIn,'e'))
          if(i.le.0.or.i.gt.j) then
            RealIndices=.true.
            call SetRealArrayTo(hf(4),ndimi,0)
          endif
        endif
      endif
      rewind(ln)
      if(ich.ne.0) go to 9999
      call OpenFile(96,FileIn,'formatted','old')
      if(ErrJana.ne.0) go to 9100
      if(Fractional.or.FreeFormat) then
        read(96,FormA80) t80
        call mala(t80)
        k=0
        if(Fractional) then
          call kus(t80,k,Cislo)
          if(Cislo.ne.'fract') rewind 96
        else
          itecka=0
          call RozdelMezerou(t80,'-')
          call RozdelMezerou(t80,'+')
          do 1600i=1,3
            call kus(t80,k,Cislo)
            if(index(Cislo,'.').gt.0) then
              RealIndices=.true.
              itecka=1
              go to 1620
            endif
1600      continue
1620      rewind 96
        endif
      endif
      if(TypeIn.eq.5) then
        read(96,FormA80,err=9000,end=3000) t80
        if(EqIgCase(t80,'import_report_begin')) then
          call FeChybne(-1.,-1.,'only m95 prepared by DATRED can be '//
     1                  'imported',' ',0,SeriousError)
          go to 9100
        endif
        rewind 96
      endif
      t80='     0 reflections already imported'
      write(t80(1:6),103) nrefp
      call FeTxOut(-1.,-1.,t80)
      nvyh=0
      nall=0
      avis=0.
      nobs=0
      rimax=0.
1800  if(TypeIn.eq.5) then
        read(96,formatIn,err=9000,end=3000)
     1    no,(ih(i),i=1,ndim95),uhly,ri,rs,expos,iflg,corrf,tbar,dircos
        if(no.gt.0) then
          pom=corrf(1)*corrf(2)
          ri=ri*pom
          rs=rs*pom
          corrf(1)=1.
          corrf(2)=1.
        else
          go to 1800
        endif
        call indtr(ih,trp,ihp,ndim95)
        if(ihp(1).gt.900) go to 1800
      else
        if(FreeFormat) then
          read(96,FormA80,err=9000,end=3000) p80
          if(p80.eq.' ') go to 1800
          call RozdelMezerou(p80,'-')
          call RozdelMezerou(p80,'+')
          k=0
          do 1810i=1,ndim95i
            call kus(p80,k,Cislo)
            call posun(Cislo,itecka)
            if(RealIndices) then
              read(Cislo,101) h(i)
            else
              read(Cislo,FormI15) ihp(i)
            endif
1810      continue
          call kus(p80,k,Cislo)
          call posun(Cislo,1)
          read(Cislo,101) ri
          call kus(p80,k,Cislo)
          call posun(Cislo,1)
          read(Cislo,101) rs
        else
          if(RealIndices) then
            read(96,FormatIn,err=9000,end=3000)(h(i),i=1,3),ri,rs
          else
            read(96,FormatIn,err=9000,end=3000)(ihp(i),i=1,ndim95i),ri,
     1        rs
            if(TypeIn.eq.2.or.TypeIn.eq.3) then
              ri=10.*ri
              rs=10.*rs
            endif
          endif
        endif
        if(RealIndices) then
          do 2005i=1,3
            if(abs(h(i)).gt..0001) go to 2040
2005      continue
        else
          if(ihp(1).gt.900) go to 3000
          do 2006i=1,ndim95
            if(ihp(i).ne.0) go to 2040
2006      continue
          go to 3000
        endif
      endif
2040  if(TypeIn.lt.3.or.TypeIn.eq.6) then
        if(ri.gt.rs) then
          rs=2.*rs*ri
        else
          rs=2.*rs**2
        endif
        ri=ri**2
      endif
      if(RealIndices) then
        call multm(h,TrmIn,hf,1,ndim95,ndim95)
        if(ndim.eq.ndim95) then
          do 2042i=1,ndim
            ih(i)=nint(hf(i))
            if(abs(hf(i)-float(ih(i))).gt.difi(i)) go to 2900
2042      continue
        endif
      else
        do 2043j=1,ndim95
          h(j)=ihp(j)
2043    continue
        call multm(h,TrmIn,hf,1,ndim95,ndim95)
      endif
      if(ndim.gt.ndim95) then
        if(.not.RealIndices) then
          do 2045j=1,ndim
            if(j.le.ndim95) then
              hf(j)=hf(j)/float(nsup(j))
            else
              hf(j)=0.
            endif
2045      continue
        endif
      else if(ndim.eq.ndim95) then
        if(Fractional) then
          do 2200i=1,3
            hf(i)=hf(i)/float(ihf(i))
2200      continue
        else if(itwin.gt.1.and.itwi.gt.0) then
          mmax=0
          do 2210i=4,ndim
            mmax=max(iabs(nint(hf(i))),mmax)
2210      continue
          do 2230i=1,3
            h(i)=hf(i)
            do 2220j=1,ndimi
              h(i)=h(i)+qu(i,j,1,KPhase)*hf(j+3)
2220        continue
2230      continue
          call multm(h,rtwi(1,iatw),hf,1,3,3)
        else
          do 2240i=1,ndim95
            ih(i)=nint(hf(i))
            if(abs(float(ih(i))-hf(i)).gt..01) go to 2900
2240      continue
          itw=itwi
          go to 2600
        endif
      else
        mmax=0
        do 2300i=4,ndim95
          mmax=max(iabs(nint(hf(i))),mmax)
2300    continue
        do 2330i=1,3
          do 2310j=1,ndimi
            hf(i)=hf(i)+qu(i,j,1,KPhase)*hf(j+3)
2310      continue
          do 2320j=1,ndim95-ndim
            hf(i)=hf(i)+quit(i,j)*hf(j+ndim)
2320      continue
2330    continue
      endif
      call RestorePhase(1)
      if(itwi.gt.0) then
        call IndFromIndReal(hf,mmax,difi,ih,itw,isw,-1.)
      else
c        call CopyVekI(ihp,ih,ndim)
        isw=1
        itw=itwi
      endif
      if(isw.le.0) go to 2900
2600  nrefp=nrefp+1
      if(mod(nrefp,100).eq.0) then
        write(t80(1:6),103) nrefp
        call FeTxOutCont(t80)
      endif
      expos=float(nrefp)*.1
      ri=ri*RscFak
      rs=rs*RscFak
      write(ln,format95) nrefp,(ih(i),i=1,ndim),uhly,ri,rs,expos,iq,
     1                   itw,corrf,tbar,dircos
      go to 1800
2900  call EM9NejdouPotvory(ihp,hf,ri,rs,ndim95,avis,nall,nobs,nvyh,
     1                      iha,hfa,ipor,ria,rsa,rimax,3.,RealIndices)
      go to 1800
3000  write(t80(1:6),103) nrefp
      call FeTxOutCont(t80)
      call FeTxOutEnd
      call iom94(1)
      if(ndim.gt.ndim95) then
        if(nsups.gt.3) then
          do 3015j=1,ndimi
            do 3010i=1,3
              qu(i,j,1,KPhase)=quo(i,j)
              qui(i,j,KPhase)=qu(i,j,1,KPhase)-quir(i,j,KPhase)
3010        continue
3015      continue
        endif
        if(ncomp.gt.1) call setmet(0)
      endif
      if(kcommen.ne.0.and.ndim.eq.4) call iom50(0,0)
      if(nvyh.eq.0) then
        call FeMsgOut(-1.,-1.,'All observed reflections were '//
     1                'successfully imported')
      else
        if(nall.ne.0) then
          avis=avis/float(nall)
        else
          avis=0.
        endif
        write(TextInfo(1),'(''Overall           n(all) :'',i6,
     1                      '' n(obs) :'',i6)') nall,nobs
        write(TextInfo(2),'(18x,''Average(I/Sig(I)) : '',f5.2)')
     1        avis
        if(nvyh.ne.15) call Indexx(nvyh,ria,ipor)
        TextInfo(3)='            List of the strongest ones'
        if(RealIndices) then
          write(TextInfo(4),'(3(4x,a1,3x))')(indices(i),i=1,3)
          idl=25
        else
          write(TextInfo(4),EM9Form1)(indices(i),i=1,ndim95)
          idl=idel(TextInfo(4))+1
        endif
        TextInfo(4)(idl:)='       I      sig(I)  I/sig(I)'
        do 5250i=5,nvyh+4
          k=ipor(i-4)
          if(RealIndices) then
            write(TextInfo(i),'(3f8.3)')(hfa(j,k),j=1,ndim95)
          else
            write(TextInfo(i),EM9Form2)(iha(j,k),j=1,ndim95)
          endif
          pom1=-float(ria(k))*.01
          pom2= float(rsa(k))*.01
          write(TextInfo(i)(idl:),'(1x,2f9.1,f9.2)') pom1*pom2,pom2,pom1
5250    continue
        Ninfo=nvyh+4
        call FeInfoOut(-1.,-1.,'Summary of reflections which couldn''t '
     1                //'be imported')
      endif
      go to 9999
9000  call FeTxOutEnd
      call FeReadError(96)
9100  ich=1
9999  call CloseIfOpened(96)
      return
100   format(i1)
101   format(f15.0)
103   format(i6)
      end
      subroutine EM9CheckFileIn(FileIn,FileIn94,in,ich)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      character*(*) FileIn,FileIn94
      logical ExistFile
      ich=0
      if(ExistFile(FileIn)) then
        if(in.eq.5) then
          if(FileIn.eq.fln(:ifln)//'.m95') then
            LinuxString='the file : '//FileIn(:idel(FileIn))//
     1                  ' must be handled'
            call FeChybne(-1.,-1.,LinuxString,
     1                    'directly and not imported',0,SeriousError)
            go to 9000
          endif
          if(.not.ExistFile(FileIn94)) then
            LinuxString='the file "'//FileIn94(:idel(FileIn94))//
     1                  '"doesn''t exist'
            call FeChybne(-1.,-1.,LinuxString,'Try again',0,
     1                    SeriousError)
            go to 9000
          endif
        endif
      else
        LinuxString='the file "'//FileIn(:idel(FileIn))//
     1              '"doesn''t exist'
        call FeChybne(-1.,-1.,LinuxString,'Try again',0,SeriousError)
        go to 9000
      endif
      go to 9999
9000  ich=1
9999  return
      end
      subroutine EM9ResetAssFile(FileIn,FileIn94)
      character*(*) FileIn,FileIn94
      j=idel(FileIn)
      if(j.eq.idel(FileIn94)) then
        i=index(FileIn,'.m95')
        if(i.gt.0) then
          if(FileIn94(i:i+3).eq.'.m94') FileIn94='.m94'
        endif
      endif
      return
      end
      subroutine EM9NewImpFile(lnk)
      include 'params.cmn'
      include 'basic.cmn'
      character*4  ext
      lnk=NextLogicNumber()
      write(ext,'(''.l'',i2)') lnk
      if(ext(3:3).eq.' ') ext(3:3)='0'
      call OpenFile(lnk,fln(:ifln)//ext,'formatted','unknown')
      return
      end
      subroutine EM9NejdouPotvory(ih,hf,ri,rs,ndim,avis,NExt,NExtObs,
     1                            NExt15,iha,hfa,ipor,ria,rsa,rimax,
     2                            EM9ObsLim,RealIndices)
      dimension ih(6),iha(6,15),ipor(15),hfa(3,15),hf(3)
      integer   ria(15),rsa(15)
      logical RealIndices
      pom=ri/rs
      avis=avis+ri/rs
      NExt=NExt+1
      if(pom.gt.EM9ObsLim) then
        NExtObs=NExtObs+1
        if(pom.gt.rimax) then
          if(NExt15.lt.15) then
            NExt15=NExt15+1
            k=NExt15
          else
            k=ipor(15)
          endif
          ria(k)=nint(-pom*100.)
          rsa(k)=nint( rs*100.)
          if(RealIndices) then
            do 1000i=1,3
              hfa(i,k)=hf(i)
1000        continue
          else
            do 1100i=1,ndim
              iha(i,k)=ih(i)
1100        continue
          endif
          if(NExt15.ge.15) then
            call Indexx(15,ria,ipor)
            rimax=-float(ria(ipor(15)))*.01
          endif
        endif
      endif
      return
      end
      integer function EM9SortIndex(ihref)
      include 'params.cmn'
      include 'basic.cmn'
      dimension ihref(6),hh(6),hhp(6)
      EM9SortIndex=9
      do 1200i=1,ncomp
        do 1000j=1,ndim
          hh(j)=ihref(j)
1000    continue
        call multm(hh,zvi(1,i,KPhase),hhp,1,ndim,ndim)
        mm=0
        do 1100j=1,ndim
          n=nint(hhp(j))
          if(abs(float(n)-hhp(j)).gt..0001) go to 1200
          if(j.ge.4) mm=mm+iabs(n)
1100    continue
        EM9SortIndex=min(mm,EM9SortIndex)
1200  continue
      EM9SortIndex=EM9SortIndex+2
      return
      end
